
BASE:I("Loading Welcome message script and Static manager")
local AirbossStennis = AIRBOSS:New("CVN-72")

local playerZoneVisits = {}
local globalCallsignAssignments = {}


local atisZones = {
    ["Al Dhafra"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Al_Dhafra_AFB, runways = {"13", "31"}},
    ["Sharjah"] = {frequency = 270.70, airbaseName = AIRBASE.PersianGulf.Sharjah_Intl, runways = {"12", "30"}},
    ["BandarAbbas"] = {frequency = 270.90, airbaseName = AIRBASE.PersianGulf.Bandar_Abbas_Intl, runways = {"03L", "03R", "21L", "21R"}},
    ["Khasab"] = {frequency = 270.70, airbaseName = AIRBASE.PersianGulf.Khasab, runways = {"01"}},
    ["Qeshm Island"] = {frequency = 270.80, airbaseName = AIRBASE.PersianGulf.Qeshm_Island, runways = {"17", "35"}},
    ["Carrier Group"] = {frequency = 305.50, airbaseName = "CVN-72", runways = {"N/A"}},
    ["Al Minhad AFB"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Al_Minhad_AFB, runways = {"09", "27"}},
    ["Fujairah Intl"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Fujairah_Intl, runways = {"11", "29"}},
    ["Ras Al Khaimah"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Ras_Al_Khaimah_Intl, runways = {"16", "34"}},
	["Al Ain"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Al_Ain_Intl, runways = {"01", "19"}},
	["Kish intl"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Kish_Intl, runways = {"27R", "27L", "09R", "09L"}},
	["Bandar Lengeh"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Bandar_Lengeh, runways = {"26", "08"}},
	["BandarAbbas"] = {frequency = 270.90, airbaseName = AIRBASE.PersianGulf.Bandar_Abbas_Intl, runways = {"03L", "03R", "21L", "21R"}}
	
}
local atisZoneNames = {
	["Bandar Abbas Intl"] = {frequency = 270.90, airbaseName = AIRBASE.PersianGulf.Bandar_Abbas_Intl, runways = {"03L", "03R", "21L", "21R"}},
    ["Al Dhafra AFB"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Al_Dhafra_AFB, runways = {"13", "31"}},
    ["Sharjah Intl"] = {frequency = 270.70, airbaseName = AIRBASE.PersianGulf.Sharjah_Intl, runways = {"12", "30"}},
    ["Ras Al Khaimah Intl"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Ras_Al_Khaimah_Intl, runways = {"16", "34"}},
	["Al Ain Intl"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Al_Ain_Intl, runways = {"01", "19"}},
	["Kish Intl"] = {frequency = 270.50, airbaseName = AIRBASE.PersianGulf.Kish_Intl, runways = {"27R", "27L", "09R", "09L"}}


}
-- Define all zones
local allZones = {
    "Al Dhafra", "Sharjah", "BandarAbbas", "Khasab", "Qeshm Island", "Carrier Group",
    "Al Huti", "Al Ain", "Fujairah Intl", "Al Minhad AFB", "Ras Al Khaimah", "Alpha", "Charlie",
    "Convoy", "Oil Fields", "Radio Tower", "Dehbarez", "Paregaan", "Khamets", "Samathe",
    "Bandar Lengeh", "Delta", "Sunny", "Ramp-Kongo", "Factory", "Foxtrot", "Echo", "Golf", "Lar",
    "Kish intl", "Al Khatim", "Al Dahid"
}


airbaseStatics = {
	["Al Khatim"] = {"Khatimammo", "Khatimfuel", "Khatimtent1", "Khatimtent2", "Khatimtent3", "Khatimtent4", "Khatimcommand", "Khatimwind"},
    ["Al Huti"] = {"Hutiammo", "FHutifuel", "Hutitent1", "Hutitent2", "Hutitent3", "Hutitent4", "Huticommand", "Hutiwind"},
    ["Al Dahid"] = {"Dahidammo", "Dahidfuel", "Dahidtent1", "Dahidtent2", "Dahidtent3", "Dahidtent4", "Dahidcenter", "Dahidwind"},
    ["Radio Tower"] = {"Radioammo", "Radiofuel", "Radiotent1", "Radiotent2", "Radiotent3", "Radiotent4", "Radiocenter", "Radiowind"},
    ["FARP Delta"] = {"Deltaoammo", "Deltaofuel", "Deltatent1", "Deltatent2", "Deltatent3", "Deltatent4", "Deltaommand", "Deltawind"},
    ["Factory"] = {"Factoryammo", "Factoryfuel", "Factorytent1", "Factorytent2", "Factorytent3", "Factorytent4", "Factorycomand", "Factorywind"},
    ["FARP Golf"] = {"Farpgolfammo", "Farpgolffuel", "Farpgolftent1", "Farpgolftent2", "Farpgolftent3", "Farpgolftent4", "Farpgolfcommand", "Farpgolfwind"},
    ["FARP Echo"] = {"FarpEchoammo", "FarpEchofuel", "FarpEchotent1", "FarpEchotent2", "FarpEchotent3", "FarpEchotent4", "FarpEchocommand", "FarpEchowind"},
    ["FARP Sunny"] = {"Sunnyammo", "Sunnyfuel", "Sunnytent1", "Sunnytent2", "Sunnytent3", "Sunnytent4", "Sunnycommand", "Sunnywind"},
    ["Ramp-Kongo"] = {"Kongoammo", "Kongofuel", "Kongotent1", "Kongotent2", "Kongotent3", "Kongotent4", "Kongocommand", "Kongowind"},
    ["Foxtrot"] = {"Foxtrotammo", "Foxtrotfuel", "Foxtrottent1", "Foxtrottent2", "Foxtrottent3", "Foxtrottent4", "Foxtrotcommand", "Foxtrotwind"},
    ["FARP Khamets"] = {"Khametsammo", "Khametsfuel", "Khametstent1", "Khametstent2", "Khametstent3", "Khametstent4", "Khametscommand", "Khametswind"},
    ["Samathe"] = {"Samatheammo", "Samathefuel", "Samathetent1", "Samathetent2", "Samathetent3", "Samathetent4", "Samathecommand", "Samathewind"},
	["Paregaan"] = {"Paregaanammo", "Paregaanfuel", "Paregaantent1", "Paregaanent2", "Paregaantent3", "Paregaantent4", "Paregaancommand", "Paregaanwind"},

}

staticDetails = {}

function GatherStaticDetails()
    for airbaseName, staticNames in pairs(airbaseStatics) do
        for _, staticName in ipairs(staticNames) do
            local static = STATIC:FindByName(staticName)
            if static and static:IsAlive() then
                local point = static:GetPointVec3()
                local typeName = static:GetTypeName()
                local coalitionSide = static:GetCoalition()
                local heading = static:GetHeading()
                staticDetails[staticName] = {
                    airbaseName = airbaseName,
                    typeName = typeName,
                    coalitionSide = coalitionSide,
                    point = point,
                    heading = heading,
                }
            else
                env.info("Static not found or not alive: " .. staticName)
            end
        end
    end
end

function RespawnStaticsForAirbase(airbaseName, coalitionSide)
    local statics = airbaseStatics[airbaseName]
    if not statics then
        return
    end

    local countryID
    if coalitionSide == coalition.side.BLUE then
        countryID = country.id.USA
    elseif coalitionSide == coalition.side.RED then
        countryID = country.id.RUSSIA
    else
        return
    end

    for _, staticName in ipairs(statics) do
        local static = STATIC:FindByName(staticName, false)
        if static and static:IsAlive() then
            static:ReSpawn(countryID)
        else
            local details = staticDetails[staticName]
            if details then
                local headingInRadians = math.rad(details.heading)
                local spawnTemplate = {
                    ["name"] = staticName,
                    ["type"] = details.typeName,
                    ["category"] = "Static",
                    ["country"] = countryID,
                    ["heading"] = headingInRadians,
                    ["position"] = details.point,
                }
                local spawnStatic = SPAWNSTATIC:NewFromTemplate(spawnTemplate, countryID)
                spawnStatic:SpawnFromCoordinate(COORDINATE:NewFromVec3(details.point))
            end
        end
    end
end

staticDetails = {}
function GatherStaticDetails()
    for airbaseName, staticNames in pairs(airbaseStatics) do
        for _, staticName in ipairs(staticNames) do
            local static = STATIC:FindByName(staticName)
            if static and static:IsAlive() then
                local point = static:GetPointVec3()
                local typeName = static:GetTypeName()
                local coalitionSide = static:GetCoalition()
                local heading = static:GetHeading()
                staticDetails[staticName] = {
                    airbaseName = airbaseName,
                    typeName = typeName,
                    coalitionSide = coalitionSide,
                    point = point,
                    heading = heading,
                }
            else
                env.info("Static not found or not alive: " .. staticName)
            end
        end
    end
end

function RespawnStaticsForAirbase(airbaseName, coalitionSide)
    local statics = airbaseStatics[airbaseName]
    if not statics then
        return
    end

    local countryID
    if coalitionSide == coalition.side.BLUE then
        countryID = country.id.USA
    elseif coalitionSide == coalition.side.RED then
        countryID = country.id.RUSSIA
    else
        return
    end

    for _, staticName in ipairs(statics) do
        local static = STATIC:FindByName(staticName, false)
        if static and static:IsAlive() then
            static:ReSpawn(countryID)
        else
            local details = staticDetails[staticName]
            if details then
                local headingInRadians = math.rad(details.heading)
                local spawnTemplate = {
                    ["name"] = staticName,
                    ["type"] = details.typeName,
                    ["category"] = "Static",
                    ["country"] = countryID,
                    ["heading"] = headingInRadians,
                    ["position"] = details.point,
                }
                local spawnStatic = SPAWNSTATIC:NewFromTemplate(spawnTemplate, countryID)
                spawnStatic:SpawnFromCoordinate(COORDINATE:NewFromVec3(details.point))
            end
        end
    end
end

GatherStaticDetails()

local aircraftAssignments = {
    ["F.A.18"] = {
        ["Arctic1"] = {
            IFFs = {1400, 1401, 1402, 1403},
            assignments = {}
        },
        ["Bender2"] = {
            IFFs = {1404, 1405, 1406, 1407},
            assignments = {}
        },
        ["Crimson3"] = {
            IFFs = {1410, 1411, 1412, 1413},
            assignments = {}
        },
        ["Dusty4"] = {
            IFFs = {1300, 1301, 1302, 1303},
            assignments = {}
        },
        ["Lion3"] = {
            IFFs = {1310, 1311, 1312, 1313},
            assignments = {}
        },
    },
    ["F.16CM"] = {
        ["Jester1"] = {
            IFFs = {1500, 1501, 1502, 1503},
            assignments = {}
        },
        ["Indy9"] = {
            IFFs = {1510, 1511, 1512, 1513},
            assignments = {}
        },
        ["Venom4"] = {
            IFFs = {1610, 1611, 1612, 1613},
            assignments = {}
        },
    },
    ["A.10C"] = {
        ["Hawg8"] = {
            IFFs = {1330, 1331, 1332, 1333},
            assignments = {}
        },
        ["Tusk2"] = {
            IFFs = {1350, 1351, 1352, 1353},
            assignments = {}
        },
        ["Pig7"] = {
            IFFs = {1340, 1341, 1342, 1343},
            assignments = {}
        },
    },
    ["AH.64D"] = {
        ["Rage9"] = {
            IFFs = {1610, 1611, 1612, 1613},
            assignments = {}
        },
        ["Salty1"] = {
            IFFs = {1620, 1621, 1622, 1623},
            assignments = {}
        },
    },
    ["AJS37"] = {
        ["Fenris6"] = {
            IFFs = {1060, 1061, 1062, 1063},
            assignments = {}
        },
        ["Grim7"] = {
            IFFs = {1070, 1071, 1072, 1073},
            assignments = {}
        },
    },
    ["UH.1H"] = {
        ["Nitro5"] = {
            IFFs = {1050, 1051, 1052, 1053},
            assignments = {}
        },
    },
    ["CH.47F"] = { 
        ["Greyhound3"] = { 
            IFFs = {1370, 1371, 1372, 1373}, 
            assignments = {}
        },
    },
    ["F.15E.S4"] = { 
        ["Hitman3"] = { 
            IFFs = {1360, 1361, 1362, 1363}, 
            assignments = {}
        },
    },
    ["F.14.B"] = { 
        ["Elvis5"] = { 
            IFFs = {1100, 1101, 1102, 1103}, 
            assignments = {}
        },
        ["Mustang4"] = { 
            IFFs = {1104, 1105, 1106, 1107}, 
            assignments = {}
        },
    },
}

local zoneAssignments = {}

function logZoneAssignments()
    BASE:I("Zone Assignments:")
    for zone, assignments in pairs(zoneAssignments) do
        BASE:I("Zone: " .. zone)
        for fullCallsign, assignedPlayer in pairs(assignments) do
            BASE:I("    Callsign: " .. fullCallsign .. " -> Player: " .. assignedPlayer)
        end
    end
end
local function isCallsignUsedInOtherZones(fullCallsign, currentZone)
    for zone, assignments in pairs(zoneAssignments) do
        if assignments[fullCallsign] then
            if zone ~= currentZone then
                return true
            elseif assignments[fullCallsign] then
                return true
            end
        end
    end
    return false
end
function getAssignedCallsignAndIFF(groupName)
    for prefix, typeAssignments in pairs(aircraftAssignments) do
        if string.find(groupName, prefix) then
            for callsign, details in pairs(typeAssignments) do
                for i, IFF in ipairs(details.IFFs) do
                    local fullCallsign = callsign .. "" .. i
                    if not isCallsignUsedInOtherZones(fullCallsign, zoneName) then
                        return fullCallsign, IFF
                    end
                end
            end
        end
    end
    return nil, nil
end

function findOrAssignSlot(playerName, groupName, zoneName)
    for assignedZone, assignments in pairs(zoneAssignments) do
        for callsign, assignedPlayer in pairs(assignments) do
            if assignedPlayer == playerName then
                releaseSlot(playerName, assignedZone)
                zoneAssignments[assignedZone][callsign] = nil
                globalCallsignAssignments[playerName] = nil
                BASE:I("Removed old callsign " .. callsign .. " for player: " .. playerName)
                break
            end
        end
    end

    zoneAssignments[zoneName] = zoneAssignments[zoneName] or {}

    for prefix, typeAssignments in pairs(aircraftAssignments) do
        if string.find(groupName, prefix) then
            local preferredOrder
			if prefix == "F.A.18" then
				preferredOrder = {"Arctic1", "Bender2", "Crimson3", "Dusty4", "Lion3"}
			elseif prefix == "F.16CM" then
				preferredOrder = {"Jester1", "Indy9", "Venom4"}
			elseif prefix == "A.10C" then
				preferredOrder = {"Hawg8", "Tusk2", "Pig7"}
			elseif prefix == "AH.64D" then
				preferredOrder = {"Rage9", "Salty1"}
			elseif prefix == "AJS37" then
				preferredOrder = {"Fenris6", "Grim7"}
			elseif prefix == "UH.1H" then
				preferredOrder = {"Nitro5"}
			elseif prefix == "CH.47F" then
				preferredOrder = {"Greyhound3"}
			elseif prefix == "F.15E.S4" then
				preferredOrder = {"Hitman3"}
			elseif prefix == "F.14.B" then
				preferredOrder = {"Elvis5", "Mustang4"}
			end
			
            if #preferredOrder == 1 then
                local baseCallsign = preferredOrder[1]

                local maxNumber = 0
                for zone, assignments in pairs(zoneAssignments) do
                    for fullCallsign, assignedPlayer in pairs(assignments) do
                        if string.find(fullCallsign, baseCallsign) then
                            local number = tonumber(string.sub(fullCallsign, -1))
                            if number and number > maxNumber then
                                maxNumber = number
                            end
                        end
                    end
                end

                local newCallsign = baseCallsign .. (maxNumber + 1)
                local IFF = typeAssignments[baseCallsign].IFFs[(maxNumber % #typeAssignments[baseCallsign].IFFs) + 1]


                zoneAssignments[zoneName][newCallsign] = playerName
                globalCallsignAssignments[playerName] = {callsign = newCallsign, zoneName = zoneName}

                BASE:I(string.format("Assigned %s to player %s in zone %s", newCallsign, playerName, zoneName))
                logZoneAssignments()
                return newCallsign, IFF
            end

            local availableMainCallsign = nil
            local existingPrefixInZone = nil

            for _, mainCallsign in ipairs(preferredOrder) do
                for i = 1, #typeAssignments[mainCallsign].IFFs do
                    local fullCallsign = mainCallsign .. "" .. i
                    if zoneAssignments[zoneName][fullCallsign] then
                        existingPrefixInZone = mainCallsign
                        break
                    end
                end
                if existingPrefixInZone then
                    break
                end
            end

            if not existingPrefixInZone then
                for _, mainCallsign in ipairs(preferredOrder) do
                    local isUsedInOtherZones = false
                    for zone, assignments in pairs(zoneAssignments) do
                        if zone ~= zoneName then  -- We are only interested in checking other zones
                            for fullCallsign, assignedPlayer in pairs(assignments) do
                                if string.find(fullCallsign, mainCallsign) then
                                    isUsedInOtherZones = true
                                    break
                                end
                            end
                        end
                    end
                    if not isUsedInOtherZones then
                        availableMainCallsign = mainCallsign
                        break
                    end
                end
            else
                availableMainCallsign = existingPrefixInZone  -- Continue with the same flight prefix in this zone
            end

            if availableMainCallsign then
                for i, IFF in ipairs(typeAssignments[availableMainCallsign].IFFs) do
                    local fullCallsign = availableMainCallsign .. "" .. i
                    if not zoneAssignments[zoneName][fullCallsign] then
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        BASE:I(string.format("Assigned %s to player %s in zone %s", fullCallsign, playerName, zoneName))
                        logZoneAssignments()
                        return fullCallsign, IFF
                    end
                end
            end
           
            for _, mainCallsign in ipairs(preferredOrder) do
                for i, IFF in ipairs(typeAssignments[mainCallsign].IFFs) do
                    local fullCallsign = mainCallsign .. "" .. i
                    if not isCallsignUsedInOtherZones(fullCallsign, zoneName) and zoneAssignments[zoneName][fullCallsign] == nil then
                        
                        zoneAssignments[zoneName][fullCallsign] = playerName

                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        BASE:I(string.format("Assigned %s to player %s in zone %s (cycled back, first available)", fullCallsign, playerName, zoneName))
                        logZoneAssignments()  
                        return fullCallsign, IFF
                    end
                end
            end

            for _, mainCallsign in ipairs(preferredOrder) do
                for i, IFF in ipairs(typeAssignments[mainCallsign].IFFs) do
                    local fullCallsign = mainCallsign .. "" .. i
                    if not zoneAssignments[zoneName][fullCallsign] then
                        zoneAssignments[zoneName][fullCallsign] = playerName


                        globalCallsignAssignments[playerName] = {callsign = fullCallsign, zoneName = zoneName}

                        BASE:I(string.format("Assigned %s to player %s in zone %s (cycled back, fallback)", fullCallsign, playerName, zoneName))
                        logZoneAssignments()
                        return fullCallsign, IFF
                    end
                end
            end
        end
    end


    return nil, nil
end
function releaseSlot(playerName, zoneName)

    if zoneAssignments[zoneName] then
        for callsign, assignedPlayer in pairs(zoneAssignments[zoneName]) do
            if assignedPlayer == playerName then

                zoneAssignments[zoneName][callsign] = nil


                globalCallsignAssignments[playerName] = nil

                BASE:I(string.format("Released %s from player %s in zone %s", callsign, playerName, zoneName))
                break
            end
        end
    end
end

function sendGreetingToPlayer(playerUnitID, greetingMessage)
    trigger.action.outTextForUnit(playerUnitID, greetingMessage, 55)
end
function sendDetailedMessageToPlayer(args)
    local playerUnitID = args[1]
    local message = args[2]
    local playerGroupID = args[3]
    trigger.action.outTextForUnit(playerUnitID, message, 120)
    if trigger.misc.getUserFlag(180) == 0 then
        trigger.action.outSoundForGroup(playerGroupID, "admin.wav")
    end
end
local function getAltimeter()
    local coord = COORDINATE:NewFromVec3({x = 0, y = 0, z = 0})
    local pressure_hPa = coord:GetPressure(0)  
    local pressureInHg = pressure_hPa * 0.0295300
    return string.format("Altimeter %.2f", pressureInHg)
end
local function getBRC()
    if AirbossStennis then
        local brc = AirbossStennis:GetBRC()
        return string.format("BRC %d°", brc)
    else
        return "BRC data unavailable"
    end
end
local function getAirbaseWind(airbaseName)
    local airbase = AIRBASE:FindByName(airbaseName)
    if airbase then
        local airbaseCoord = airbase:GetCoordinate()  
        local windDirection, windSpeed = airbaseCoord:GetWind(0)
        if windDirection and windSpeed then
            local windSpeedKnots = math.floor(windSpeed * 1.94384)
            windDirection = (windDirection + 360) % 360
            return string.format("Wind is %03d° at %d", windDirection, windSpeedKnots), windDirection
        else
            return "Wind data unavailable", nil
        end
    else
        return "Airbase not found", nil
    end
end
local function calculateFallbackRunway(zoneName)
    local zoneInfo = atisZones[zoneName]
    if not zoneInfo or not zoneInfo.runways then
        trigger.action.outText("No runway data available for zone: " .. zoneName, 10)
        return "Active runway data unavailable."
    end
    
    
    local _, windDirection = getAirbaseWind(zoneInfo.airbaseName)
    if windDirection == nil then
        return "Wind direction data unavailable."
    end

    local bestRunway = nil
    local smallestDelta = 360

   
    for _, runway in ipairs(zoneInfo.runways) do
        local runwayHeading = tonumber(runway:sub(1, 2)) * 10
        local delta = math.abs(runwayHeading - windDirection)
        if delta > 180 then 
            delta = 360 - delta
        end
        if delta < smallestDelta then
            smallestDelta = delta
            bestRunway = runway
        end
    end

    if bestRunway then
        return string.format("Active runway is %s", bestRunway)
    else
        return "No suitable runway found based on wind."
    end
end
local function fetchActiveRunway(zoneName)
    local airbase = AIRBASE:FindByName(atisZones[zoneName].airbaseName)
    if not airbase then
        trigger.action.outText("Airbase/FARP conflict detected or airbase not found: " .. atisZones[zoneName].airbaseName, 10)
        return "Airbase data unavailable."
    end

    local windMessage, windDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
    if windDirection == nil then
        return "Wind direction data unavailable."
    end

    local activeRunway = airbase:GetRunwayIntoWind()
    if activeRunway then
        local runwayName = airbase:GetRunwayName(activeRunway)
        if runwayName and runwayName ~= "" then
            
            return string.format("Active runway is %s", runwayName)
        end
    end

    
    return calculateFallbackRunway(zoneName, windDirection)
end

local function getCarrierWind()
    local cvn = UNIT:FindByName("CVN-72")
    if cvn then
        local cvnCoord = cvn:GetCoordinate()
        local windDirection, windSpeed = cvnCoord:GetWind(0)
        if windDirection and windSpeed then
            local windSpeedKnots = windSpeed * 1.94384  
            windDirection = (windDirection + 360) % 360
            return string.format("Wind is %03d° at %d", windDirection, windSpeedKnots)
        else
            return "Wind data unavailable"
        end
    else
        return "Carrier not found"
    end
end
local function getPlayerWind(playerCoord)
    local playerPosition = playerCoord:GetVec3()
    local windVector = atmosphere.getWind(playerPosition)
    if windVector then
        local windSpeedMps = math.sqrt(windVector.x^2 + windVector.z^2)
        local windSpeedKnots = math.floor(windSpeedMps * 1.94384)
        local originalWindDirection = math.deg(math.atan2(windVector.z, windVector.x))
        originalWindDirection = (originalWindDirection + 360) % 360
        local originatingWindDirection = (originalWindDirection + 180) % 360
        return string.format("Wind is %03d° at %d", originatingWindDirection, windSpeedKnots), originatingWindDirection
    else
        return "Wind data unavailable", nil
    end
end
local function getPlayerTemperature(playerCoord)
    local playerPosition = playerCoord:GetVec3()
    local temperatureCelsius = playerCoord:GetTemperature(playerPosition.y)  -- Getting temperature at the player's altitude (ASL)
    
    if temperatureCelsius then
        return string.format("Temperature is %d°C", temperatureCelsius)
    else
        return "Temperature data unavailable"
    end
end

local function getPlayerWeatherReport(playerCoord)
    local windMessage, windDirection = getPlayerWind(playerCoord)
    local temperatureMessage = getPlayerTemperature(playerCoord)


    local weatherReport = string.format("%s\n%s", windMessage, temperatureMessage)

    return weatherReport
end

-- ATIS MENU --

local function sendATISInformation(client, group, zoneName)
    local messageText
    
    if string.find(zoneName, "Carrier") then
        local windMessage = getCarrierWind()
        local brcMessage = getBRC()  
        local altimeterMessage = getAltimeter()
        messageText = string.format("ATIS for Mother:\n\n%s, %s\n\n%s", windMessage, altimeterMessage, brcMessage or "BRC data unavailable")
        MESSAGE:New(messageText, 15, ""):ToUnit(client)
    else
        
        local windMessage, windDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
        if windMessage == "Wind data unavailable" or windMessage == "Airbase not found" then
            messageText = string.format("ATIS for %s:\n\n%s", zoneName, windMessage)
        else
            local runwayInfo = fetchActiveRunway(zoneName, windDirection)
            messageText = string.format("ATIS for %s:\n\n%s, %s\n\n%s.", zoneName, windMessage, getAltimeter(), runwayInfo or "Runway information not available")
        end
        MESSAGE:New(messageText, 20, ""):ToUnit(client)
    end
end


local MainMenu = {}
local static = STATIC:FindByName("EventMan", true)

local function getClosestFriendlyAirbaseInfo(client)
    if not client or not client:IsAlive() then
        BASE:E("Client is nil or not alive.")
        return
    end

    local playerCoord = client:GetCoordinate()
    if not playerCoord then
        MESSAGE:New("Unable to determine player position.", 15, ""):ToUnit(client)
        return
    end

    local closestZoneName, closestDistance, closestBearing = nil, math.huge, nil

    for zoneName, details in pairs(atisZones) do
        if not string.find(zoneName, "Carrier") then  -- Exclude zones with "Carrier" in their name
            local airbase = AIRBASE:FindByName(details.airbaseName)
            if airbase and airbase:GetCoalition() == coalition.side.BLUE then
                local distanceToAirbase = playerCoord:Get2DDistance(airbase:GetCoordinate())
                local bearingToAirbase = playerCoord:HeadingTo(airbase:GetCoordinate(), nil)

                if distanceToAirbase < closestDistance then
                    closestZoneName = zoneName
                    closestDistance = distanceToAirbase
                    closestBearing = bearingToAirbase
                end
            end
        end
    end

    if not closestZoneName then
        MESSAGE:New("No friendly airbases in the ATIS zones found nearby.", 15, ""):ToUnit(client)
        return
    end

    local distanceInNM = closestDistance * 0.000539957
    local displayName = closestZoneName .. (WaypointList[closestZoneName] or "")
    local windMessage, windDirection = getAirbaseWind(atisZones[closestZoneName].airbaseName)
    local altimeterMessage, runwayInfo = "", ""

    if windMessage ~= "Wind data unavailable" and windMessage ~= "Airbase not found" then
        altimeterMessage = getAltimeter()
        runwayInfo = fetchActiveRunway(closestZoneName, windDirection) or "Runway information not available"
    end

    local messageText = string.format("Closest Friendly Airbase: %s\n\nDistance: %.2f NM, Bearing: %03d°\n\n%s%s%s",
		  displayName, distanceInNM, closestBearing, windMessage, altimeterMessage ~= "" and (", " .. altimeterMessage) or "", runwayInfo ~= "" and ("\n\n" .. runwayInfo) or "")

    MESSAGE:New(messageText, 20, ""):ToUnit(client)
end


function SetupATISMenu(client)
    local group = client:GetGroup()
    if not group then return end

    local groupID = group:GetName()

    if MainMenu[groupID] then
        MainMenu[groupID]:Remove()
    end

    local mainMenu = MENU_GROUP:New(group, "ATIS and Closest Airbase")
    MainMenu[groupID] = mainMenu

    local atisMenu = MENU_GROUP:New(group, "ATIS Information", mainMenu)
    MENU_GROUP_COMMAND:New(group, "Get Closest Friendly Airbase", mainMenu, getClosestFriendlyAirbaseInfo, client)

    MENU_GROUP_COMMAND:New(group, "Get ATIS for Mother", atisMenu, sendATISInformation, client, group, "Carrier")

    local currentMenu = atisMenu
    local menuItemCount = 2

    for zoneName, details in pairs(atisZones) do
        if not zoneName:find("Carrier") then
            local airbase = AIRBASE:FindByName(details.airbaseName)
            if airbase and airbase:GetCoalitionName() == 'Blue' then
                if menuItemCount >= 9 then
                    currentMenu = MENU_GROUP:New(group, "Next Page...", atisMenu)
                    menuItemCount = 0
                end
                MENU_GROUP_COMMAND:New(group, "Get ATIS for " .. zoneName, currentMenu, sendATISInformation, client, group, zoneName)
                menuItemCount = menuItemCount + 1
            end
        end
    end
end
function static:onBaseCapture(_event)
local event = _event -- Core.Event#EVENTDATA
if event.id == EVENTS.BaseCaptured and event.Place then
	local capturedBaseName = event.Place:GetName()  
	local coalitionSide = event.Place:GetCoalition()

	if (atisZoneNames[capturedBaseName] or atisZones[capturedBaseName]) and event.Place:GetCoalition() == coalition.side.BLUE then  
	
			
			local clientSet = SET_CLIENT:New():FilterCategories("plane"):FilterCoalitions("blue"):FilterAlive():FilterOnce()
			clientSet:ForEachClient(function(client)
				SetupATISMenu(client)
				
				
				local messageText = string.format("ATIS for %s is now available.", capturedBaseName)
				MESSAGE:New(messageText, 20, ""):ToClient(client)
			end)
		end
	end  
end

function static:onPlayerSpawn(_event)
    local event = _event
    if event.id == EVENTS.PlayerEnterAircraft and event.IniUnit and event.IniPlayerName then
        local player = event.IniUnit
        local playerName = player:GetPlayerName()
        
        if player:GetUnitCategory() == Unit.Category.AIRPLANE then
            SetupATISMenu(player)
        end
        
        local group = player:GetGroup()
        local groupName = group:GetName()
        
        for _, zoneName in ipairs(allZones) do
            local zone = ZONE:New(zoneName)
            if zone and zone:IsCoordinateInZone(player:GetCoordinate()) then
                local playerUnitID = player:GetID()
                local playerGroupID = player:GetGroup():GetID()
                

                local isNewVisit = not playerZoneVisits[playerName] or not playerZoneVisits[playerName][zoneName]
                playerZoneVisits[playerName] = playerZoneVisits[playerName] or {}
                playerZoneVisits[playerName][zoneName] = true


                local assignedCallsign, assignedIFF = findOrAssignSlot(playerName, groupName, zoneName)

                local altimeterMessage = getAltimeter()
                local temperatureMessage = getPlayerTemperature(player:GetCoordinate())
                local greetingMessage, detailedMessage
                

                if string.find(zoneName, "Carrier") then
                    local brcMessage = getBRC()
                    local carrierWindMessage = getCarrierWind()

                    if assignedCallsign and assignedIFF then
                        greetingMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\nYou have been assigned to %s, IFF %d.\n\nStandby for weather report from Mother.", playerName, assignedCallsign, assignedIFF)
                        detailedMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\n%s, %s, %s\n\n%s\n\nOnce 7 miles out, push Tactical on CH 3.", assignedCallsign, carrierWindMessage, temperatureMessage, altimeterMessage, brcMessage)
                    else
                        greetingMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\nStandby for weather and BRC.", playerName)
                        detailedMessage = string.format("Welcome aboard Abraham Lincoln, %s!\n\n%s, %s, %s\n\n%s\n\nOnce 7 miles out, push Tactical on CH 3.", playerName, carrierWindMessage, temperatureMessage, altimeterMessage, brcMessage)
                    end

                else

                    local windMessage, displayWindDirection

                    if atisZones[zoneName] then
                        windMessage, displayWindDirection = getAirbaseWind(atisZones[zoneName].airbaseName)
                        local activeRunwayMessage = fetchActiveRunway(zoneName, displayWindDirection)

                        if isNewVisit then
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nStandby for weather and ATIS information.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            else
                                greetingMessage = string.format("Welcome to %s, %s!\n\nStandby for weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            end

                        else
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nYou'll receive the latest weather and ATIS info shortly.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            else
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nStandby for updated weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\n%s.\n\nOnce airborne push Tactical on CH 3.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage, activeRunwayMessage)
                            end
                        end
                    else

                        local playerCoord = player:GetCoordinate()
                        windMessage, _ = getPlayerWind(playerCoord)
                        temperatureMessage = getPlayerTemperature(playerCoord)

                        if isNewVisit then
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nStandby for weather information.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage)
                            else
                                greetingMessage = string.format("Welcome to %s, %s!\n\nStandby for weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage)
                            end

                        else
                            if assignedCallsign and assignedIFF then
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nYou have been assigned to %s, IFF %d.\n\nYou'll receive updated weather information shortly.", zoneName, playerName, assignedCallsign, assignedIFF)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, assignedCallsign, windMessage, temperatureMessage, altimeterMessage)
                            else
                                greetingMessage = string.format("Welcome back to %s, %s!\n\nStandby for updated weather information.", zoneName, playerName)
                                detailedMessage = string.format("Welcome back to %s, %s!\n\n%s, %s, %s.\n\nOnce airborne push Tactical on CH 3.\n\nDon't forget supplies.", zoneName, playerName, windMessage, temperatureMessage, altimeterMessage)
                            end
                        end
                    end
                end

                sendGreetingToPlayer(playerUnitID, greetingMessage)
                timer.scheduleFunction(sendDetailedMessageToPlayer, {playerUnitID, detailedMessage, playerGroupID}, timer.getTime() + 60)
            end
        end
    end
end
function static:onPlayerLeaveUnit(_event)
    BASE:I("onPlayerLeaveUnit called")

    local event = _event

    if event.id == EVENTS.PlayerLeaveUnit or event.id == EVENTS.PilotDead then
        if event.IniPlayerName then
            local playerName = event.IniPlayerName
            BASE:I("Player leaving unit: " .. playerName)

            if globalCallsignAssignments[playerName] then
                local callsignInfo = globalCallsignAssignments[playerName]
                local zoneName = callsignInfo.zoneName
                BASE:I("Player had assignment: " .. callsignInfo.callsign .. " in zone " .. zoneName)

                releaseSlot(playerName, zoneName)
                globalCallsignAssignments[playerName] = nil
            else
                BASE:I("No global assignment found for player: " .. playerName)
            end
        else
            BASE:I("IniPlayerName is nil. Player might have disconnected without a proper event.")

            local clientSet = SET_CLIENT:New():FilterCategories("plane"):FilterCoalitions("blue"):FilterAlive():FilterOnce()

            for playerName, callsignInfo in pairs(globalCallsignAssignments) do
                local isPlayerAlive = false

                clientSet:ForEachClient(function(client)
                    if client:GetPlayerName() == playerName then
                        isPlayerAlive = true
                    end
                end)

                if not isPlayerAlive then
                    local zoneName = callsignInfo.zoneName
                    BASE:I("Removing dead or disconnected player: " .. playerName .. " from zone " .. zoneName)
                    releaseSlot(playerName, zoneName)
                    globalCallsignAssignments[playerName] = nil
                end
            end
        end
    else
        BASE:I("Event ID does not match PlayerLeaveUnit or PilotDead")
    end
end

function static:onF16capLanding(_event)
    local event = _event

    if event.id == EVENTS.Land and event.IniUnit then
        local landedUnit = event.IniUnit
        local group = landedUnit:GetGroup()
        local groupName = group:GetName()

        if string.sub(groupName, 1, 6) == "cap-" or string.sub(groupName, 1, 4) == "sead" or string.sub(groupName, 1, 3) == "cas" then

            local filteredGroup = SET_GROUP:New():FilterPrefixes("cap", "sead", "cas"):FilterAlive():FilterOnce()

            SCHEDULER:New(nil, function()
                filteredGroup:ForEachGroupAlive(function(GROUP)
                    local units = GROUP:GetUnits()

                    if units and #units > 0 then
                        for _, unit in pairs(units) do
                            local speedInKMH = unit:GetVelocityKMH()
                            if speedInKMH < 100 then
                                unit:Destroy()
                            end
                        end
                    else
                        env.info("No valid units found in the group: " .. GROUP:GetName())
                    end
                end)
            end, {}, 5)
        end
    end
end

function WeaponImpact(Weapon)
    local impactPos = Weapon:GetImpactVec3()
    if impactPos then
        trigger.action.explosion(impactPos, 150)
        BASE:I("Explosion triggered at impact position.")
    end
end

function WeaponTrack(Weapon)
    if not Weapon.isTrackingMessageShown then
        local target = Weapon:GetTarget()
        if target and target:GetCategory() == Unit.Category.HELICOPTER and target:GetCoalition() == coalition.side.RED then
            BASE:I("Tracking RED coalition helicopter target.")
            Weapon.isTrackingMessageShown = true
        elseif not target then
            BASE:I("No valid target found, stopping tracking.")
            Weapon:StopTrack()
        end
    end
end

function static:onEventShot(EventData)
    local eventdata = EventData
    if eventdata and eventdata.weapon then
        local initiator = eventdata.IniUnit

        if initiator and initiator:GetPlayerName() then
            local playerName = initiator:GetPlayerName()
            local weapon = WEAPON:New(eventdata.weapon)
            if weapon:IsMissile() then
                BASE:I(string.format("Missile detected from player %s, starting tracking.", playerName))
                weapon:SetFuncTrack(WeaponTrack)
                weapon:SetFuncImpact(WeaponImpact)
                weapon:StartTrack()
            end
        end
    end
end

static:HandleEvent(EVENTS.Shot, static.onEventShot)
static:HandleEvent(EVENTS.Land, static.onF16capLanding)
static:HandleEvent(EVENTS.PlayerEnterAircraft, static.onPlayerSpawn)
static:HandleEvent(EVENTS.BaseCaptured, static.onBaseCapture)
static:HandleEvent(EVENTS.PlayerLeaveUnit, static.onPlayerLeaveUnit)

BASE:I("Welcome message script and Static manager loading completed")