env.info("ZoneSetup: is loading.")

function merge(tbls)
	local res = {}
	for i,v in ipairs(tbls) do
		for i2,v2 in ipairs(v) do
			table.insert(res,v2)
		end
	end
	
	return res
end

function allExcept(tbls, except)
	local tomerge = {}
	for i,v in pairs(tbls) do
		if i~=except then
			table.insert(tomerge, v)
		end
	end
	return merge(tomerge)
end

upgrades = {
    carrier = {
        blue = { "bShip", "bShip" },
        red = {}
    },
    airfield = {
        blue = { "bInfantry", "bSamIR", "bSam", "bArmor", "bSampa" },
        red = { "rInfantry", "rArmor", "rSam", "rSam2", "rSam3" }
    },
	Bandarabbas = {
        blue = { "bInfantry", "bSamIR", "bSam", "bArmor", "bSam3" },
        red = { "rInfantry", "rArmor", "Red SAM SHORAD Fixed Bandar", "Red SAM SA-6 Fixed Bandar", "Red SAM SA-11 Fixed Bandar" }
    },
    airfield2 = {
        blue = { "bInfantry", "bSamIR", "bSam", "bArmor" },
        red = { "rInfantry", "rArmor", "rSam2", "rSam3" }
    },
    farp = {
        blue = { "bInfantry", "bArmor", "bSam" },
        red = { "rInfantry", "rArmor", "rSam" }
    },
	
	kishFixed = {
        blue = { "bInfantry", "bArmor", "bSam" },
        red = { "rInfantry", "Red SAM SHORAD Fixed Kish", "rArmor", "Red SAM SA-6 Fixed Kish" }
    },
	
	farpkongo = {
        blue = { "bInfantry", "bArmor", "bSam" },
        red = {"rArmor", "Red SAM SHORAD Fixed Kongo", "Red SAM SA-3 Fixed Kongo" }
    },
    farp2 = {
        blue = { "bInfantry", "bArmor", "bSam" },
        red = { "rInfantry", "rArmor", "rSamIR" }
    },
    farp3 = {
        blue = { "bInfantry", "bArmor", "bSam" },
        red = { "rInfantry", "rArmor", "redPD5" }
    },
    regularzone = {
        blue = { "bInfantry", "bArmor", "bSamIR" },
        red = { "rInfantry", "rArmor", "rSamIR" }
    },
	Foxtrotzone = {
        blue = { "bInfantry", "bArmor", "bSamIR" },
        red = { "rInfantry", "rArmor", "Red SAM SHORAD Fixed Foxtrot" }
    },
	regularzoneParegaan = {
        blue = { "bInfantry", "bArmor", "bSamIR" },
        red = { "rArmor", "Red SAM SHORAD SA-15 Fixed Paregaan", "Red SAM SA-11 Fixed Paregaan" }
    },
    specialSAM = {
        blue = { "bInfantry", "bSamIR", "bInfantry", "bInfantry", "bSamBig" },
        red = { "rInfantry", "rSamIR", "rInfantry", "rSam", "rSamBig" }
    },
    specialSAM2 = {
        blue = { "bInfantry", "bSamIR", "bInfantry", "bInfantry", "bSamBig" },
        red = { "rInfantry", "redArmor2", "Red SAM SHORAD Fixed samsite", "Red SAM SA-3 Fixed Samsite", "Red SAM SA-2 Fixed Samsite" }
    },
	specialSAM2fixed = {
        blue = {},
        red = { "Red SAM SA-11 Fixed", "Red SAM SHORAD Fixed", "Red SAM SHORAD Fixed 2" }
    },
    mission2 = {
        blue = { "blueInfantry", "blueArmor" },
        red = { "redInfantry1", "redInfantry2", "redArmor2", "redPD2" }
    },
	InsurgentCampmission = {
        blue = {},
        red = { "InsurgentCamp Fixed Group", "InsurgentCamp Fixed Group2", "InsurgentCamp Fixed Group3Convoy", "Red SAM SHORAD Fixed Group4" }
    },
    mission3 = {
        blue = { "blueInfantry", "blueArmor" },
        red = { "redInfantry2", "redArmor1", "redPD3", "Static Chemical tank A-1", "FactoryBuilding1-1", "Static Chemical tank A-6", "FactoryBuilding2-1" }
    },
    mission4 = {
        blue = { "blueInfantry", "blueArmor" },
        red = { "redInfantry2", "redArmor1", "redPD3", "redSA10", "FactoryBuilding1-1", "Static Chemical tank A-6" }
    },
    mission5Fixed = {
        blue = { "blueInfantry", "blueArmor" },
        red = { "TankFactory Fixed Group 1", "TankFactory Fixed Group 2", "TankFactory Fixed Group 3", "Red SAM SHORAD Fixed TankFacotory", "Red SAM SHORAD Fixed TankFacotory-2" }
    },
	KhasabDefencefixed = {
        blue = { "blueInfantry", "blueArmor" },
        red = { "Red SAM SHORAD Fixed Khasab", "Red SAM SA-6 Khasab Fixed" }
    },
	 
	SharjahDefencefixed = {
        blue = { "blueInfantry", "blueArmor" },
        red = { "Red SAM SHORAD Fixed Sharjah Defence", "Red SAM SA-6 Fixed Sharja" }
    },
    specialLar = {
        blue = { "bInfantry", "bSamIR", "bSam2", "bSam3", "bSamBig", "bSamFinal" },
        red = { "rSamIR", "rSam2", "redArmor1", "rSamBig" }
    },
	
	specialLarSAM = {
		blue = {"blue SAM Fixed-Lar-Defence" },
        red = {"Red SAM SA-11 LAR Fixed", "Red SAM SHORAD LAR Fixed 2", "Red SAM SHORAD LAR Fixed", "Red SAM SHORAD LAR AAA Fixed" }
    },
    convoy = {
        blue = { "bInfantry" },
        red = { "rInfantry", "rInfantry", "rArmor" }
    }
}

flavor = {
	aldhafra = 'WPT 1\nAl Dhafra',
	carrier = 'Carrier group',
	alain = 'WPT 3\nAin means eyes Al Ain is THE eyes', 
	alhuti = 'WPT 4\n Its a city name close by',
	minhad = 'WPT 5\nHere can we Land',
	sharjah = 'WPT 6\nCloser to the AO',
	fujairah = 'WPT 8\nNice view',
	khaimah = 'WPT 9\nKhaimah means Tent',
	alpha = 'WPT 11\nDefensive position next to the village of Al Ima',
	khasab = 'WPT 13\nAirport of Khasab.\nWill let us launch helicopter attacks from a bit closer to the action.',
	charlie = 'WPT 10\nDefensive position next to an old command bunker.\nWill provide allied air patrol to help capture Bravo',
	convoy = 'WPT 12\nSupply convoy detained southwest of Bravo.\nKeep damage to the trucks to a minimum while liberating this area.\nWe could really use the supplies.',
	bandarabbas = 'WPT 15\nAirbase next to the city of Bandar Abbas.\nCapturing it will provide us with valuable aircraft to use for our cause.',
	radio = 'WPT 16\nCommand bunker on the outskirts of Minab.\nIf we capture it, we can launch CAS from the nearby airport\nto get some much needed intel on the enemy.',
	oilfields = 'WPT 18\nOil extraction and Refinery west of BandarAbbas.\nCapture it to get a steady stream of income, or just destroy it to put a hole in the enemy wallet.',
	dehbarez = 'WPT 17\nDefensive position NorthEast of Minab',
	paregaan = 'WPT 19\nDefensive position NorthEast of Factory',
	khamets = 'WPT 21\nDefensive position NorthWest of Factory',
	bandarlengeh = 'WPT 28\nDefensive arifield with quick respons for sea intercepts',
	samathe = 'WPT 20\nDefensive position in good cover by the mountains',
	echo =  'WPT 24\nFARP next to the city of Krasnodar.\nCapturing it will let us operate our helicopters in the area.',
	sunny = 'WPT 25\nSunny is here somewhere building the never ending pit.',
	rampkongo = 'WPT 26\nLegend says its a place where poeple pretend they fly.',
	delta = 'WPT 23\nDefensive position out in the middle of nowhere',
	factory = 'WPT 22\nWeapon factory northwest of Bandar Abbas.\nWe can use it to resupply nearby bases.\nIt will also provide a steady stream of income.',
	qeshmisland = 'WPT 14\nHome to an old SA-2 site.\nIf we capture it, we might be able to get some use out of it.',
	foxtrot = 'WPT 30\nDefensive position with a nice view of the camel races',
	lar = 'WPT 31\nAirbase next to the city of Lar.\nThe home base of our enemy. Capture it to deprive them of their most valuable asset.',
	kish = 'WPT 29\nThere is a moving Shorad convoy around the island.\nThis island is guarded by SA-6 and SA-3',
	alkhatim = 'WPT 2\nit was not meant to be.',
	dahid = 'WPT 7\nit was not meant to be.',
	golf = 'WPT 27\nAnother fucking FARP.',
	chemsite = 'WPT \nThanks to the locals who have identified the smell and called us. We also need to destroy the factory',
	insurgentcamp = 'WPT \nInsurgent have taken over this smal city. Help them!.',
	secrettechfacility = 'WPT \nThey are making missiles to destroy our democracy! WATCH OUT, THE SITE IS HEAVILY GUARDED.',
	fueldepo = 'WPT \nYou got Fuel? we got democracy.',
	tankfactory = 'WPT \nIts where they build them.',
	khasabdefence = 'WPT \n This offsite location is a defence site defending Bravo / Khassab.',
	sharjadefence = 'WPT \n This offsite location is a defence site defending Sharjah.',
	qeshmislanddefence = 'WPT \n This offsite location is a defence site defending Qeshm Island.',
	
}	
WaypointList = {
    ["Al Dhafra"] = ' (1)',
    ["Al Ain"] = ' (3)',
    ["Al Huti"] = ' (4)',
    ["Al Minhad AFB"] = ' (5)',
    Sharjah = ' (6)',
    ["Fujairah Intl"] = ' (8)',
    ["Ras Al Khaimah"] = ' (9)',
    Alpha = ' (11)',
    Khasab = ' (13)',
    Charlie = ' (10)',
    Convoy = ' (12)',
    BandarAbbas = ' (15)',
    ["Radio Tower"] = ' (16)',
    ["Oil Fields"] = ' (18)',
    Dehbarez = ' (17)',
    Paregaan = ' (19)',
    Khamets = ' (21)',
    ["Bandar Lengeh"] = ' (28)',
    Samathe = ' (20)',
    Echo = ' (24)',
    Sunny = ' (25)',
    ["Ramp-Kongo"] = ' (26)',
    Delta = ' (23)',
    Factory = ' (22)',
    ["Qeshm Island"] = ' (14)',
    Foxtrot = ' (30)',
    Lar = ' (31)',
    ["Kish intl"] = ' (29)',
    ["Al Khatim"] = ' (2)',
    ["Al Dahid"] = ' (7)',
    Golf = ' (27)'
}

local filepath = 'foothold_persiangulf.lua'
if lfs then 
	local dir = lfs.writedir()..'Missions/Saves/'
	lfs.mkdir(dir)
	filepath = dir..filepath
	env.info('Foothold - Save file path: '..filepath)
end

bc = BattleCommander:new(filepath, 10, 60)
zones = {
    aldhafra = ZoneCommander:new({zone='Al Dhafra', side=2, level=5, upgrades=upgrades.airfield, crates={}, flavorText=flavor.aldhafra}),
    alhuti = ZoneCommander:new({zone='Al Huti', side=1, level=3, upgrades=upgrades.farp2, crates={}, flavorText=flavor.alhuti}),
    alain = ZoneCommander:new({zone='Al Ain', side=1, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.alain}),
    fujairah = ZoneCommander:new({zone='Fujairah Intl', side=1, level=3, upgrades=upgrades.farp, crates={}, flavorText=flavor.fujairah}),
    minhad = ZoneCommander:new({zone='Al Minhad AFB', side=1, level=4, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.minhad}),
    sharjah = ZoneCommander:new({zone='Sharjah', side=1, level=4, upgrades=upgrades.airfield, crates={}, flavorText=flavor.sharjah}),
    khaimah = ZoneCommander:new({zone='Ras Al Khaimah', side=1, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.khaimah}),
    carrier = ZoneCommander:new({zone='Carrier Group', side=2, level=2, upgrades=upgrades.carrier, crates={}, flavorText=flavor.carrier}),
    alpha = ZoneCommander:new({zone='Alpha', side=1, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.alpha}),
    khasab = ZoneCommander:new({zone='Khasab', side=1, level=3, upgrades=upgrades.farp, crates={}, flavorText=flavor.khasab}),
    charlie = ZoneCommander:new({zone='Charlie', side=1, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.charlie}),
    convoy = ZoneCommander:new({zone='Convoy', side=1, level=3, upgrades=upgrades.convoy, crates={}, flavorText=flavor.convoy}),
    bandarabbas = ZoneCommander:new({zone='BandarAbbas', side=1, level=5, upgrades=upgrades.Bandarabbas, crates={}, flavorText=flavor.bandarabbas}),
    radio = ZoneCommander:new({zone='Radio Tower', side=1, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.radio}),
    dehbarez = ZoneCommander:new({zone='Dehbarez', side=1, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.dehbarez}),
   
    bandarlengeh = ZoneCommander:new({zone='Bandar Lengeh', side=1, level=5, upgrades=upgrades.airfield, crates={}, flavorText=flavor.bandarlengeh}),
    delta = ZoneCommander:new({zone='Delta', side=1, level=3, upgrades=upgrades.farp, crates={}, flavorText=flavor.delta}),
	
	factory = ZoneCommander:new({zone='Factory', side=0, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.factory, income=2, NeutralAtStart=true, firstCaptureByRed = false}),
	golf = ZoneCommander:new({zone='Golf', side=0, level=3, upgrades=upgrades.farp, crates={}, flavorText=flavor.golf, NeutralAtStart=true, firstCaptureByRed = false}),
	oilfields = ZoneCommander:new({zone='Oil Fields', side=0, level=3, upgrades=upgrades.farp, crates={}, flavorText=flavor.oilfields, income=2, NeutralAtStart=true, firstCaptureByRed = false}),
	foxtrot = ZoneCommander:new({zone='Foxtrot', side=0, level=3, upgrades=upgrades.Foxtrotzone, crates={}, flavorText=flavor.foxtrot, NeutralAtStart=true, firstCaptureByRed = false}),
	samathe = ZoneCommander:new({zone='Samathe', side=0, level=5, upgrades=upgrades.specialSAM, crates={}, flavorText=flavor.samathe, NeutralAtStart=true, firstCaptureByRed = false}),
	paregaan = ZoneCommander:new({zone='Paregaan', side=0, level=3, upgrades=upgrades.regularzoneParegaan, crates={}, flavorText=flavor.paregaan, NeutralAtStart=true, firstCaptureByRed = false}),
	sunny = ZoneCommander:new({zone='Sunny', side=0, level=3, upgrades=upgrades.farp, crates={}, flavorText=flavor.sunny, NeutralAtStart=true, firstCaptureByRed = false}),
	khamets = ZoneCommander:new({zone='Khamets', side=0, level=3, upgrades=upgrades.regularzone, crates={}, flavorText=flavor.khamets, NeutralAtStart=true, firstCaptureByRed = false}),
	rampkongo = ZoneCommander:new({zone='Ramp-Kongo', side=0, level=3, upgrades=upgrades.farpkongo, crates={}, flavorText=flavor.rampkongo, NeutralAtStart=true, firstCaptureByRed = false}),
    lar = ZoneCommander:new({zone='Lar', side=0, level=6, upgrades=upgrades.specialLar, crates={}, flavorText=flavor.lar, income=2, NeutralAtStart=true, firstCaptureByRed = false}),
	
	    
    qeshmisland = ZoneCommander:new({zone='Qeshm Island', side=1, level=5, upgrades=upgrades.specialSAM2, crates={}, flavorText=flavor.qeshmisland}),
    echo = ZoneCommander:new({zone='Echo', side=1, level=3, upgrades=upgrades.farp3, crates={}, flavorText=flavor.echo}),

	
    kish = ZoneCommander:new({zone='Kish intl', side=1, level=4, upgrades=upgrades.kishFixed, crates={}, flavorText=flavor.kish}),
    alkhatim = ZoneCommander:new({zone='Al Khatim', side=1, level=3, upgrades=upgrades.farp3, crates={}, flavorText=flavor.alkhatim}),
    dahid = ZoneCommander:new({zone='Al Dahid', side=1, level=3, upgrades=upgrades.farp3, crates={}, flavorText=flavor.dahid}),
    insurgentcamp = ZoneCommander:new({zone='InsurgentCamp', side=1, level=4, upgrades=upgrades.InsurgentCampmission, crates={}, flavorText=flavor.insurgentcamp}),
    chemsite = ZoneCommander:new({zone='ChemSite', side=1, level=7, upgrades=upgrades.mission3, crates={}, flavorText=flavor.ChemSite}),
    secrettechfacility = ZoneCommander:new({zone='SecretTechFacility', side=1, level=4, upgrades=upgrades.mission4, crates={}, flavorText=flavor.secrettechfacility}),
    fueldepo = ZoneCommander:new({zone='Fuel Depo', side=1, level=4, upgrades=upgrades.mission2, crates={}, flavorText=flavor.fueldepo}),
    tankfactory = ZoneCommander:new({zone='TankFactory', side=1, level=7, upgrades=upgrades.mission5Fixed, crates={}, flavorText=flavor.tankfactory}),
	
	khasabdefence = ZoneCommander:new({zone='Khasab-Defence', side=1, level=3, upgrades=upgrades.KhasabDefencefixed, crates={}, flavorText=flavor.khasabdefence}),
	sharjadefence = ZoneCommander:new({zone='Sharjah-Defence', side=1, level=3, upgrades=upgrades.SharjahDefencefixed, crates={}, flavorText=flavor.sharjadefence}),
	lardefence = ZoneCommander:new({zone='Lar-Defence', side=1, level=4, upgrades=upgrades.specialLarSAM, crates={}, flavorText=flavor.lardefence}),
	qeshmislanddefence = ZoneCommander:new({zone='Qeshm-Island-Defence', side=1, level=3, upgrades=upgrades.specialSAM2fixed, crates={}, flavorText=flavor.qeshmislanddefence}),

}
zones.bandarabbas:addGroups({
	GroupCommander:new({name='bandar-supply-khasab', mission='supply', targetzone='Khasab'}),
	GroupCommander:new({name='bandar-attack-khasab', mission='attack', targetzone='Khasab'}),
	GroupCommander:new({name='bandar-patrol-khasab', mission='patrol', targetzone='Khasab'}),
	GroupCommander:new({name='bandar-patrol-bandar', mission='patrol', targetzone='BandarAbbas'}),
	GroupCommander:new({name='bandar-supply-radio-tower', mission='supply', targetzone='Radio Tower'}),
	GroupCommander:new({name='Bandar-attack-radio-tower', mission='attack', targetzone='Radio Tower'}),
	GroupCommander:new({name='bandar-patrol-khasab-blue', mission='patrol', targetzone='Khasab'}),
	GroupCommander:new({name='bandar-patrol-bandar-blue', mission='patrol', targetzone='BandarAbbas'}),
	GroupCommander:new({name='bandar-supply-khasab-blue', mission='supply', targetzone='Khasab'}),
	GroupCommander:new({name='bandar-supply-radio-tower-blue', mission='supply', targetzone='Radio Tower'}),
	GroupCommander:new({name='bandar-supply-delta', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='bandar-attack-delta', mission='attack', targetzone='Delta'}),
	GroupCommander:new({name='bandar-supply-factory', mission='supply', targetzone='Factory', condition = function() return zones.khasab.side == 2 end, urgent = zones.factory.side == 0}),
	GroupCommander:new({name='bandar-attack-factory', mission='attack', targetzone='Factory'}),
	GroupCommander:new({name='bandar-supply-delta-blue', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='bandar-supply-factory-blue', mission='supply', targetzone='Factory'}),
	GroupCommander:new({name='bandar-supply-qeshm-island-blue', mission='supply', targetzone='Qeshm Island'}),
	GroupCommander:new({name='bandar-supply-qeshm-island', mission='supply', targetzone='Qeshm Island'}),
	GroupCommander:new({name='bandar-attack-sam-site', mission='attack', targetzone='Qeshm Island'}),
	GroupCommander:new({name='bandar-supply-oilfields-blue', mission='supply', targetzone='Oil Fields'}),
	GroupCommander:new({name='bandar-supply-oil-fields', mission='supply', targetzone='Oil Fields', condition = function() return zones.khasab.side == 2 end, urgent = zones.oilfields.side == 0}),
	GroupCommander:new({name='bandar-attack-oil-fields', mission='attack', targetzone='Oil Fields'}),
	GroupCommander:new({name='bandar-naval-attack-khasab', mission='attack', targetzone='Khasab', type='surface'}),
	GroupCommander:new({name='bandar-patrol-delta-f18-blue', mission='patrol', targetzone='Delta'})
	
})
zones.delta:addGroups({
	GroupCommander:new({name='delta-supply-qeshm-island-blue', mission='supply', targetzone='Qeshm Island'}),
	GroupCommander:new({name='Delta-supply-Bandar', mission='supply', targetzone='BandarAbbas'}),
	GroupCommander:new({name='Delta-supply-Bandar-blue', mission='supply', targetzone='BandarAbbas'}),
	GroupCommander:new({name='delta-supply-sunny-blue', mission='supply', targetzone='Sunny'}),
	GroupCommander:new({name='Delta-supply-Factory', mission='supply', targetzone='Factory', condition = function() return zones.khasab.side == 2 end, urgent = zones.factory.side == 0}),
	GroupCommander:new({name='Delta-supply-echo', mission='supply', targetzone='Echo', condition = function() return zones.khasab.side == 2 end, urgent = zones.echo.side == 0})
	
})
zones.paregaan:addGroups({
	GroupCommander:new({name='Paregaan-supply-oil-fields', mission='supply', targetzone='Oil Fields'}),
	GroupCommander:new({name='Paregaan-supply-oil-fields-blue', mission='supply', targetzone='Oil Fields'}),
	GroupCommander:new({name='Paregaan-supply-samathe-blue', mission='supply', targetzone='Samathe'}),
	GroupCommander:new({name='Paregaan-supply-samathe', mission='supply', targetzone='Samathe'}),
	GroupCommander:new({name='Paregaan-supply-khamets-blue', mission='supply', targetzone='Khamets'})
})
zones.samathe:addGroups({
	GroupCommander:new({name='Samathe-supply-Paegaan', mission='supply', targetzone='Paregaan'})
	
})
zones.echo:addGroups({
	GroupCommander:new({name='Echo-Supply-qeshm-island', mission='supply', targetzone='Qeshm Island'}),
	GroupCommander:new({name='Echo-supply-Sunny', mission='supply', targetzone='Sunny', condition = function() return zones.khasab.side == 2 end, urgent = zones.sunny.side == 0}),
	GroupCommander:new({name='Echo-Supply-Delta', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='Echo-Supply-Delta-blue', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='Echo-Supply-Factory', mission='supply', targetzone='Factory', condition = function() return zones.khasab.side == 2 end, urgent = zones.factory.side == 0}),
	GroupCommander:new({name='Echo-Supply-Factory-blue', mission='supply', targetzone='Factory'}),
	GroupCommander:new({name='Echo-Supply-Golf-blue', mission='supply', targetzone='Golf'}),
	GroupCommander:new({name='Echo-attack-delta-art', mission='attack', targetzone='Delta', type='surface'}),
	GroupCommander:new({name='Echo-Attack-Bandar', mission='attack', targetzone='BandarAbbas'}),
	GroupCommander:new({name='foxtrot-krymsk-attack', mission='attack', targetzone='BandarAbbas'}),
	GroupCommander:new({name='Echo-Supply-golf', mission='supply', targetzone='Golf', condition = function() return zones.khasab.side == 2 end, urgent = zones.golf.side == 0})
})
zones.khasab:addGroups({
	GroupCommander:new({name='khasab-supply-alpha', mission='supply', targetzone='Alpha'}),
	GroupCommander:new({name='khasab-attack-alpha', mission='attack', targetzone='Alpha'}),
	GroupCommander:new({name='khasab-supply-charlie', mission='supply', targetzone='Charlie'}),
	GroupCommander:new({name='khasab-attack-charlie', mission='attack', targetzone='Charlie'}),
	GroupCommander:new({name='khasab-supply-bandar', mission='supply', targetzone='BandarAbbas'}),
	GroupCommander:new({name='khasab-supply-bandar-blue', mission='supply', targetzone='BandarAbbas'}),
	GroupCommander:new({name='khasab-supply-alpha-blue', mission='supply', targetzone='Alpha'}),
	GroupCommander:new({name='khasab-supply-charlie-blue', mission='supply', targetzone='Charlie'}),
	GroupCommander:new({name='khasab-supply-convoy-blue', mission='supply', targetzone='Convoy'}),
	GroupCommander:new({name='khasab-supply-qeshm-island-blue', mission='supply', targetzone='Qeshm Island'}),
	GroupCommander:new({name='khasab-supply-qeshm-island', mission='supply', targetzone='Qeshm Island'}),
	GroupCommander:new({name='khasab-patrol-khasab-blue', mission='patrol', targetzone='Khasab'}),
	GroupCommander:new({name='khasab-supply-Khasab-Defence', mission='supply', targetzone='Khasab-Defence', type='surface'})
})
zones.alain:addGroups({
	GroupCommander:new({name='Al-Ain-Supply-Al-Huti', mission='supply', targetzone='Al Huti'}),
	GroupCommander:new({name='Al-Ain-Supply-Al-Huti-Red', mission='supply', targetzone='Al Huti'})
})
zones.khaimah:addGroups({
	GroupCommander:new({name='khaimah-Supply-Alpha-blue', mission='supply', targetzone='Alpha'}),
	GroupCommander:new({name='khaimah-Supply-Charlie-blue', mission='supply', targetzone='Charlie'}),
	GroupCommander:new({name='khaimah-Supply-khasab-blue', mission='supply', targetzone='Khasab'}),
	GroupCommander:new({name='Khaimah-Patrol-Sharjah', mission='patrol', targetzone='Sharjah'}),
	GroupCommander:new({name='Khaimah-supply-Sharja', mission='supply', targetzone='Sharjah'}),
	GroupCommander:new({name='Khaimah-supply-fujairah', mission='supply', targetzone='Fujairah Intl'})

})
zones.fujairah:addGroups({
	GroupCommander:new({name='Fujaira-Supply-Khaimah-blue', mission='supply', targetzone='Ras Al Khaimah'}),
	GroupCommander:new({name='Fujaira-Supply-Dahid', mission='supply', targetzone='Al Dahid'}),
	GroupCommander:new({name='Fujaira-Supply-Khaimah', mission='supply', targetzone='Ras Al Khaimah'})
})	
zones.dahid:addGroups({
	GroupCommander:new({name='Dahid-Supply-Sharjah-blue', mission='supply', targetzone='Sharjah'}),
	GroupCommander:new({name='Dahid-Supply-Fujairah-blue', mission='supply', targetzone='Fujairah Intl'}),
	GroupCommander:new({name='Dahid-Supply-Sharjah', mission='supply', targetzone='Sharjah'}),
	GroupCommander:new({name='Dahid-Supply-Fujaira', mission='supply', targetzone='Fujairah Intl'})
})
zones.carrier:addGroups({
	GroupCommander:new({name='F18-CAP-carrier', mission='patrol', targetzone='Sharjah'})
})
zones.factory:addGroups({
	GroupCommander:new({name='factory-supply-delta-blue', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='factory-supply-delta', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='factory-supply-golf-blue', mission='supply', targetzone='Golf'}),
	GroupCommander:new({name='factory-supply-paregaan', mission='supply', targetzone='Paregaan', condition = function() return zones.khasab.side == 2 end, urgent = zones.paregaan.side == 0}),
	GroupCommander:new({name='factory-krymsk-supply', mission='supply', targetzone='BandarAbbas', type='surface'}),
	GroupCommander:new({name='factory-delta-supply', mission='supply', targetzone='Delta', type='surface'}),
	GroupCommander:new({name='factory-Golf-supply', mission='supply', targetzone='Golf'}),
	GroupCommander:new({name='factory-supply-khamets-blue', mission='supply', targetzone='Khamets'}),
	GroupCommander:new({name='factory-supply-khamets', mission='supply', targetzone='Khamets', urgent = zones.khamets.side == 0}),
	GroupCommander:new({name='factory-supply-sunny-blue', mission='supply', targetzone='Sunny'}),
	GroupCommander:new({name='factory-supply-sunny', mission='supply', targetzone='Sunny', condition = function() return zones.khasab.side == 2 end, urgent = zones.sunny.side == 0})
})
zones.golf:addGroups({
	GroupCommander:new({name='Golf-Attack-Echo', mission='attack', targetzone='Echo'}),
	GroupCommander:new({name='Golf-Attack-Sunny', mission='attack', targetzone='Sunny'}),
	GroupCommander:new({name='golf-supply-foxtrot', mission='supply', targetzone='Foxtrot', urgent = zones.foxtrot.side == 0}),
	GroupCommander:new({name='golf-supply-foxtrot-blue', mission='supply', targetzone='Foxtrot'}),
	GroupCommander:new({name='golf-attack-foxtrot', mission='attack', targetzone='Foxtrot'}),
	GroupCommander:new({name='golf-supply-lar', mission='supply', targetzone='Lar'}),
	GroupCommander:new({name='golf-supply-lar-blue', mission='supply', targetzone='Lar'}),
	GroupCommander:new({name='golf-attack-lar', mission='attack', targetzone='Lar'}),
	GroupCommander:new({name='golf-foxtrot-supply', mission='supply', targetzone='Foxtrot', type='surface'}),
	GroupCommander:new({name='golf-supply-bandar-lengeh-blue', mission='supply', targetzone='Bandar Lengeh'}),
	GroupCommander:new({name='golf-supply-sunny', mission='supply', targetzone='sunny'}),
	GroupCommander:new({name='Golf-Attack-Sunny', mission='attack', targetzone='sunny'}),
	GroupCommander:new({name='Golf-supply-Sunny-blue', mission='supply', targetzone='Sunny'}),
	GroupCommander:new({name='golf-supply-echo', mission='supply', targetzone='Echo'})
})
zones.lar:addGroups({
	GroupCommander:new({name='lar-supply-golf', mission='supply', targetzone='Golf'}),
	GroupCommander:new({name='lar-supply-golf-blue', mission='supply', targetzone='Golf'}),
	GroupCommander:new({name='lar-supply-foxtrot', mission='supply', targetzone='Foxtrot', condition = function() return zones.khasab.side == 2 end, urgent = zones.foxtrot.side == 0}),
	GroupCommander:new({name='lar-supply-foxtrot-blue', mission='supply', targetzone='Foxtrot'}),
	GroupCommander:new({name='lar-attack-sam-site', mission='attack', targetzone='Qeshm Island'}),
	GroupCommander:new({name='lar-attack-bandar', mission='attack', targetzone='BandarAbbas'}),
	GroupCommander:new({name='lar-attack-radio-tower', mission='attack', targetzone='Radio Tower'}),
	GroupCommander:new({name='lar-attack-factory', mission='attack', targetzone='Factory'}),
	GroupCommander:new({name='lar-attack-golf', mission='attack', targetzone='Golf'}),
	GroupCommander:new({name='lar-attack-foxtrot', mission='attack', targetzone='Foxtrot'}),
	GroupCommander:new({name='lar-patrol-golf', mission='patrol', targetzone='Golf'}),
	GroupCommander:new({name='lar-patrol-delta', mission='patrol', targetzone='Delta'}),
	GroupCommander:new({name='lar-patrol-factory', mission='patrol', targetzone='Factory'}),
	GroupCommander:new({name='lar-supply-sunny', mission='supply', targetzone='Sunny'}),
	GroupCommander:new({name='lar-supply-sunny-blue', mission='supply', targetzone='Sunny'}),
	GroupCommander:new({name='Shiraz-patrol-Lar', mission='patrol', targetzone='Lar'}),
	GroupCommander:new({name='Shiraz-patrol-Sunny', mission='patrol', targetzone='Sunny'}),
	GroupCommander:new({name='Lar-patrol-Foxtrot', mission='patrol', targetzone='Foxtrot'}),
	GroupCommander:new({name='lar-supply-ramp-kongo', mission='supply', targetzone='Ramp-Kongo'}),
	GroupCommander:new({name='Lar-supply-lar-defence', mission='supply', targetzone='Lar-Defence', type='surface'})
})
zones.rampkongo:addGroups({
	GroupCommander:new({name='ramp-kongo-supply-khamets', mission='supply', targetzone='Khamets', urgent = zones.khamets.side == 0}),
	GroupCommander:new({name='ramp-kongo-supply-khamets-blue', mission='supply', targetzone='Khamets'})
})
zones.foxtrot:addGroups({
	GroupCommander:new({name='foxtrot-golf-attack', mission='attack', targetzone='Golf'}),
	GroupCommander:new({name='Foxtrot-supply-kishi', mission='supply', targetzone='Kish Intl'}),
	GroupCommander:new({name='Foxtrot-supply-kishi-blue', mission='supply', targetzone='Kish Intl'}),
	GroupCommander:new({name='Foxtrot-supply-Lar', mission='supply', targetzone='Lar'}),
	GroupCommander:new({name='Foxtrot-supply-Lar-blue', mission='supply', targetzone='Lar'}),
	GroupCommander:new({name='foxtrot-artillery-fire-at-golf', mission='attack', targetzone='Golf', type='surface'})
})
zones.oilfields:addGroups({
	GroupCommander:new({name='oilfields-supply-bandar', mission='supply', targetzone='BandarAbbas', type='surface'}),
	GroupCommander:new({name='oilfields-supply-dehbarez-blue', mission='supply', targetzone='Dehbarez'}),
	GroupCommander:new({name='Oilfields-Supply-paragaan-blue', mission='supply', targetzone='Paregaan'})
})
zones.qeshmisland:addGroups({
	GroupCommander:new({name='qeshm-island-Patrol-Bravo', mission='patrol', targetzone='Khasab'}),
	GroupCommander:new({name='qeshm-island-Attack-Dahfra', mission='patrol', targetzone='Khasab'}),
	GroupCommander:new({name='qeshm-island-Supply-Bandar-Lengeh-blue', mission='supply', targetzone='Bandar Lengeh'}),
	GroupCommander:new({name='qeshm-island-supply-qeshm-island-defence', mission='supply', targetzone='Qeshm-Island-Defence', type='surface', condition = function() return zones.khasab.side == 2 end})
})
zones.khamets:addGroups({
	GroupCommander:new({name='Khamets-supply-samathe', mission='supply', targetzone='samathe'}),
	GroupCommander:new({name='Khamets-supply-samathe-blue', mission='supply', targetzone='samathe'}),
	GroupCommander:new({name='Khamets-supply-Paregaan', mission='supply', targetzone='Paregaan'})
})
zones.samathe:addGroups({
	GroupCommander:new({name='Samathe-patrol-Samathe', mission='patrol', targetzone='Samathe'}),
	GroupCommander:new({name='Samathe-patrol-OilFields', mission='patrol', targetzone='Oil Fields'})
})
zones.sunny:addGroups({
	GroupCommander:new({name='Sunny-Supply-Lar', mission='supply', targetzone='Lar', condition = function() return zones.khasab.side == 2 end, urgent = zones.lar.side == 0}),
	GroupCommander:new({name='Sunny-Supply-Golf', mission='supply', targetzone='Golf'}),
	GroupCommander:new({name='Sunny-Supply-Delta', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='Sunny-Supply-Factory', mission='supply', targetzone='Factory', condition = function() return zones.khasab.side == 2 end, urgent = zones.factory.side == 0}),
	GroupCommander:new({name='Sunny-Supply-Lar-blue', mission='supply', targetzone='Lar'}),
	GroupCommander:new({name='Sunny-Supply-Golf-blue', mission='supply', targetzone='Golf'}),
	GroupCommander:new({name='Sunny-Supply-Delta-blue', mission='supply', targetzone='Delta'}),
	GroupCommander:new({name='Sunny-Supply-Factory-blue', mission='supply', targetzone='Factory'}),
	GroupCommander:new({name='Sunny-Supply-kongo-blue', mission='supply', targetzone='Ramp-Kongo'}),
	GroupCommander:new({name='Sunny-Supply-kongo', mission='supply', targetzone='Ramp-Kongo', condition = function() return zones.khasab.side == 2 end, urgent = zones.rampkongo.side == 0})
})
zones.bandarlengeh:addGroups({
	GroupCommander:new({name='lengeh-supply-kish', mission='supply', targetzone='Kish intl'}),
	GroupCommander:new({name='lengeh-supply-kish-blue', mission='supply', targetzone='Kish intl'}),
	GroupCommander:new({name='lengeh-patrol-qeshm-island', mission='patrol', targetzone='Qeshm Island'}),
	GroupCommander:new({name='Bandar-Lengeh-patrol-qeshm-island', mission='patrol', targetzone='Qeshm Island'})
})
zones.aldhafra:addGroups({
	GroupCommander:new({name='al-dhafra-support-huti', mission='supply', targetzone='Al Huti'}),
	GroupCommander:new({name='al-dhafra-support-al-ain', mission='supply', targetzone='Al Ain'}),
	GroupCommander:new({name='al-dhafra-support-al-khatim', mission='supply', targetzone='Al Khatim'})
})
zones.alhuti:addGroups({
	GroupCommander:new({name='Huti-supply-Minhad-red', mission='supply', targetzone='Al Minhad AFB'}),
	GroupCommander:new({name='Huti-supply-Minhad', mission='supply', targetzone='Al Minhad AFB'}),
	GroupCommander:new({name='Huti-supply-ain-red', mission='supply', targetzone='Al Ain'})
})
zones.alain:addGroups({
	GroupCommander:new({name='Al-Ain-Attack-Al-Dhafra', mission='attack', targetzone='Al Dhafra', type='surface'}),
	GroupCommander:new({name='Al-Ain-Supply-Al-Khatim-red', mission='supply', targetzone='Al Khatim'})
})
zones.kish:addGroups({
	GroupCommander:new({name='Kishi-patrol-kishi', mission='patrol', targetzone='Foxtrot'}),
	GroupCommander:new({name='Kish-supply-Foxtrot-blue', mission='supply', targetzone='Foxtrot'}),
	GroupCommander:new({name='Kish-supply-Foxtrot', mission='supply', targetzone='Foxtrot', condition = function() return zones.khasab.side == 2 end, urgent = zones.foxtrot.side == 0}),
	GroupCommander:new({name='Kishi-attack-sead-qeshm-island', mission='attack', targetzone='Qeshm Island'})
})
zones.minhad:addGroups({
	GroupCommander:new({name='Minhad-supply-sharjah-blue', mission='supply', targetzone='Sharjah'}),
	GroupCommander:new({name='Minhad-supply-Fujairan-blue', mission='supply', targetzone='Fujairah Intl'}),
	GroupCommander:new({name='Minhad-supply-sharjah', mission='supply', targetzone='Sharjah'}),
	GroupCommander:new({name='Minhad-supply-Fujairan', mission='supply', targetzone='Fujairah Intl'})
})
zones.sharjah:addGroups({
	GroupCommander:new({name='Sharjah-Supply-Khaimah', mission='supply', targetzone='Ras Al Khaimah'}),
	GroupCommander:new({name='Sharjah-Supply-Khaimah-blue', mission='supply', targetzone='Ras Al Khaimah'}),
	GroupCommander:new({name='Sharjah-Supply-dahid', mission='supply', targetzone='Al Dahid'}),
	GroupCommander:new({name='Sharjah-Supply-dahid-blue', mission='supply', targetzone='Al Dahid'}),
	GroupCommander:new({name='Sharjah-patrol-al-minhad', mission='patrol', targetzone='Al Minhad AFB'}),
	GroupCommander:new({name='Sharjah-supply-sharjah-Defence', mission='supply', targetzone='Sharjah-Defence', type='surface'})
})
function SpawnFriendlyAssets()

	if zones.bandarabbas.wasBlue then
		local blueAwacsGroup = Group.getByName('BandarAwacs')
        if blueAwacsGroup and not Utils.isGroupActive(blueAwacsGroup) then
		    mist.respawnGroup('BandarAwacs', true)
        end
		local blueawacs0 = Group.getByName('Blue AWACS')
		if blueawacs0 and Utils.isGroupActive(blueawacs0) then
			blueawacs0:destroy()
		end
	end
	if zones.delta.wasBlue then
		local bluetanker1 = Group.getByName('Blue Tanker 1')
        if bluetanker1 and not Utils.isGroupActive(bluetanker1) then
		    mist.respawnGroup('Blue Tanker 1', true)
        end
		
		local bluetanker2 = Group.getByName('Blue Tanker 2')
        if bluetanker2 and not Utils.isGroupActive(bluetanker2) then
		    mist.respawnGroup('Blue Tanker 2', true)
        end
	end
	if zones.khasab.wasBlue then
		local Silkworm = Group.getByName('Blue Silkworm')
        if Silkworm and not Utils.isGroupActive(Silkworm) then
		    mist.respawnGroup('Blue Silkworm', true)
		end
	end
end
mist.scheduleFunction(SpawnFriendlyAssets, {}, timer.getTime() + 10)

function checkAndDisableFriendlyZones()
     if zones.khasab.wasBlue and zones.bandarabbas.wasBlue and zones.charlie.wasBlue and
		zones.alpha.wasBlue and (zones.convoy.wasBlue or not zones.convoy.active) then
       	zones.charlie:disableFriendlyZone()
		zones.alpha:disableFriendlyZone()
		zones.convoy:disableFriendlyZone()
						
	end

    if  zones.khasab.wasBlue and zones.sharjah.wasBlue and zones.alkhatim.wasBlue and
		zones.minhad.wasBlue and zones.aldhafra.wasBlue and zones.fujairah.wasBlue and
		zones.dahid.wasBlue and zones.khaimah.wasBlue and zones.alhuti.wasBlue then
        zones.sharjah:disableFriendlyZone()
		zones.alkhatim:disableFriendlyZone()
		zones.alain:disableFriendlyZone()
		zones.minhad:disableFriendlyZone()
		zones.aldhafra:disableFriendlyZone()
		zones.fujairah:disableFriendlyZone()
		zones.dahid:disableFriendlyZone()
		zones.khaimah:disableFriendlyZone()
		zones.alhuti:disableFriendlyZone()
	end
end
		
mist.scheduleFunction(checkAndDisableFriendlyZones, {}, timer.getTime() + 5)

zones.sharjah.isHeloSpawn = true
zones.bandarlengeh.isHeloSpawn = true
zones.kish.isHeloSpawn = true
zones.khaimah.isHeloSpawn = true
zones.minhad.isHeloSpawn = true
zones.fujairah.isHeloSpawn = true
zones.alain.isHeloSpawn = true
zones.bandarabbas.isHeloSpawn = true
zones.khasab.isHeloSpawn = true
zones.echo.isHeloSpawn = true
zones.foxtrot.isHeloSpawn = true
zones.sunny.isHeloSpawn = true
zones.dahid.isHeloSpawn = true
zones.radio.isHeloSpawn = true
zones.alhuti.isHeloSpawn = true
zones.alkhatim.isHeloSpawn = true
zones.qeshmisland.isHeloSpawn = true
zones.factory.isHeloSpawn = true
zones.aldhafra.isHeloSpawn = true
zones.delta.isHeloSpawn = true
zones.golf.isHeloSpawn = true
zones.rampkongo.isHeloSpawn = true
zones.khamets.isHeloSpawn = true
zones.samathe.isHeloSpawn = true
zones.paregaan.isHeloSpawn = true

zones.sharjah.airbaseName = "Sharjah Intl"
zones.bandarlengeh.airbaseName = "Bandar Lengeh"
zones.kish.airbaseName = "Kish Intl"
zones.khaimah.airbaseName = "Ras Al Khaimah Intl"
zones.minhad.airbaseName = "Al Minhad AFB"
zones.fujairah.airbaseName = "Fujairah Intl"
zones.alain.airbaseName = "Al Ain Intl"
zones.bandarabbas.airbaseName = "Bandar Abbas Intl"
zones.khasab.airbaseName = "Khasab"
zones.echo.airbaseName = "FARP Echo"
zones.foxtrot.airbaseName = "Foxtrot"
zones.sunny.airbaseName = "FARP Sunny"
zones.dahid.airbaseName = "Al Dahid"
zones.radio.airbaseName = "Radio Tower"
zones.alhuti.airbaseName = "Al Huti"
zones.alkhatim.airbaseName = "Al Khatim"
zones.qeshmisland.airbaseName = "Qeshm Island"
zones.factory.airbaseName = "Factory"
zones.aldhafra.airbaseName = "Al Dhafra AFB"
zones.delta.airbaseName = "FARP Delta"
zones.golf.airbaseName = "FARP Golf"
zones.rampkongo.airbaseName = "Ramp-Kongo"
zones.khamets.airbaseName = "FARP Khamets"
zones.samathe.airbaseName = "Samathe"
zones.paregaan.airbaseName = "Paregaan"


for i,v in pairs(zones) do
	bc:addZone(v)
end

bc:addConnection("Al Dhafra","Al Huti")
bc:addConnection("Al Dhafra","Al Khatim")
bc:addConnection("Al Khatim","Al Ain")
bc:addConnection("Al Huti","Al Ain")
bc:addConnection("Al Minhad AFB","Al Huti")
bc:addConnection("Fujairah Intl","Al Minhad AFB")
bc:addConnection("Al Minhad AFB","Sharjah")
bc:addConnection("Al Dahid","Sharjah")
bc:addConnection("Al Dahid","Fujairah Intl")
bc:addConnection("Ras Al Khaimah","Fujairah Intl")
bc:addConnection("Charlie","Ras Al Khaimah")
bc:addConnection("Ras Al Khaimah","Alpha")
bc:addConnection("Alpha","Khasab")
bc:addConnection("Khasab-Defence","Khasab")
bc:addConnection("Khasab","BandarAbbas")
bc:addConnection("Khasab","Charlie")
bc:addConnection("Khasab","Convoy")
bc:addConnection("Sharjah","Ras Al Khaimah")
bc:addConnection("Sharjah","Sharjah-Defence")
bc:addConnection("Khasab","Qeshm Island")
bc:addConnection("BandarAbbas","Oil Fields")
bc:addConnection("BandarAbbas","Radio Tower")
bc:addConnection("BandarAbbas","Dehbarez")
bc:addConnection("Dehbarez","Oil Fields")
bc:addConnection("Paregaan","Factory")
bc:addConnection("Paregaan","Oil Fields")
bc:addConnection("Factory","Khamets")
bc:addConnection("Golf","Bandar Lengeh")
bc:addConnection("Bandar Lengeh","Qeshm Island")
bc:addConnection("BandarAbbas","Factory")
bc:addConnection("BandarAbbas","Delta")
bc:addConnection("Samathe","Khamets")
bc:addConnection("Samathe","Paregaan")
bc:addConnection("Factory","Delta")
bc:addConnection("Delta","Echo")
bc:addConnection("Echo","Golf")
bc:addConnection("Foxtrot","Lar")
bc:addConnection("Golf","Lar")
bc:addConnection("Delta","Qeshm Island")
bc:addConnection("Echo","Qeshm Island")
bc:addConnection("Qeshm-Island-Defence","Qeshm Island")
bc:addConnection("BandarAbbas","Qeshm-Island-Defence")
bc:addConnection("Kish intl","Bandar Lengeh")
bc:addConnection("Kish intl","Foxtrot")
bc:addConnection("Golf","Foxtrot")
bc:addConnection("Golf","Sunny")
bc:addConnection("Sunny","Khamets")
bc:addConnection("Factory","Sunny")
bc:addConnection("Lar","Sunny")
bc:addConnection("Lar","Lar-Defence")
bc:addConnection("Sunny","Echo")
bc:addConnection("Ramp-Kongo","Sunny")
bc:addConnection("Lar","Ramp-Kongo")
bc:addConnection("Khamets","Ramp-Kongo")
bc:addConnection("Dehbarez","SecretTechFacility")
bc:addConnection("Radio Tower","TankFactory")
bc:addConnection("ChemSite","Ras Al Khaimah")
bc:addConnection("Al Ain","Fuel Depo")
bc:addConnection("Fujairah Intl","Fuel Depo")
bc:addConnection("InsurgentCamp","Ras Al Khaimah")
bc:addConnection("InsurgentCamp","Al Dahid")

zones.radio:addCriticalObject('CommandCenter1')
zones.qeshmisland:addCriticalObject('CommandCenter2')
zones.factory:addCriticalObject('FactoryBuilding1')
zones.factory:addCriticalObject('FactoryBuilding2')
zones.tankfactory:addCriticalObject('Factory2')
zones.tankfactory:addCriticalObject('Factorybuildning')

zones.convoy:addCriticalObject('convoy1')
zones.convoy:addCriticalObject('convoy2')
zones.convoy:addCriticalObject('convoy3')
zones.convoy:addCriticalObject('convoy4')

zones.khasabdefence:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Khasab Defence is no more\n+500 credits',20)
end, 'disablekhasabdefence')

zones.qeshmislanddefence:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Qeshm island Defence Defence is no more\n+500 credits',20)
end, 'disableqeshmislanddefence')

zones.sharjadefence:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Sharjah Defence is no more\n+500 credits',20)
end, 'disablesharjadefence')

zones.lardefence:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Lar Defence is no more\n+500 credits',20)
end, 'disablelardefence')


zones.insurgentcamp:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Insurgent camp is no more\n+500 credits',20)
end, 'disableinsurgentcamp')

zones.chemsite:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'chemsite is no more\n+500 credits',20)
end, 'disablechemsite')

zones.fueldepo:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Fueldepo is no more\n+500 credits',20)
end, 'disablefueldepo')

zones.secrettechfacility:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Secret tech facility is destroyed\n+500 credits',20)
end, 'disablesecrettechfacility')

zones.tankfactory:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Great work! Tank factory is now destroyed\n+500 credits',20)
end, 'disabletankfactory')


local missionCompleted = false

local checkMissionComplete = function(event, sender)
    local done = true
    for i, v in ipairs(bc:getZones()) do
        if v.side == 1 then
            done = false
            break
        end
    end

    if done then
        missionCompleted = true  -- Set the flag when mission is complete
        trigger.action.outText("Enemy has been defeated. \n\nMission Complete.", 120)
        
        -- Schedule the audio to play after a 5-second delay
        timer.scheduleFunction(function()
            trigger.action.outSoundForCoalition(2, "BH.ogg")
        end, {}, timer.getTime() + 5)
    end
end

zones.convoy:registerTrigger('lost', function (event, sender)
	local convoyItems = {'convoy1', 'convoy2', 'convoy3', 'convoy4'}
	
	local message = "Convoy liberated"
	local totalLost = 0
	for i,v in ipairs(convoyItems) do
		if not StaticObject.getByName(v) then
			totalLost = totalLost + 1
		end
	end
	
	if totalLost > 0 then
		local percentLost = math.ceil((totalLost / #convoyItems) * 100)
		percentLost = math.min(percentLost, 100)
		percentLost = math.max(percentLost, 1)
		message = message .. ' but we lost ' .. percentLost .. '% of the trucks.'
	else
		message = message .. '. We recovered all of the supplies.'
	end
	
	local creditsEarned = (#convoyItems - totalLost) * 250
	message = message .. '\n\n+' .. creditsEarned .. ' credits'
	
	bc:addFunds(2, creditsEarned)
	
	trigger.action.outTextForCoalition(2, message, 15)
end, 'convoyLost', 1)

local showCredIncrease = function(event, sender)
	trigger.action.outTextForCoalition(sender.side, '+' .. math.floor(sender.income * 360) .. ' Credits/Hour', 5)
end

zones.oilfields:registerTrigger('captured', showCredIncrease, 'oilfieldcaptured')
zones.factory:registerTrigger('captured', showCredIncrease, 'factorycaptured')


zones.bandarabbas:registerTrigger('captured', function(event, sender)
	local kr = bc:getZoneByName('BandarAbbas')
	if kr.side == 1 then
		local krforces = { 'krymsk-gforce-1', 'krymsk-gforce-2', 'krymsk-gforce-3', 'krymsk-tforce-1' }
		for _, v in ipairs(krforces) do
			local g = Group.getByName(v)
			if g then
				g:destroy()
			end
		end
	end
end, 'bandarabbascaptured')



for i, v in ipairs(bc:getZones()) do
    v:registerTrigger('lost', checkMissionComplete, 'missioncompleted')
end

-- Destroy existing groups
Group.getByName('F16Cap1'):destroy()
Group.getByName('F16Cap2'):destroy()
Group.getByName('F16Cap3'):destroy()

-- Register shop item for 'cap'
bc:registerShopItem('cap', 'CAP', 100, function(sender)
    local grname = 'F16Cap1'
    if (zones.bandarabbas.wasBlue and zones.qeshmisland.wasBlue and zones.khasab.wasBlue) then
        grname = 'F16Cap2'
    elseif (zones.delta.wasBlue and zones.factory.wasBlue and zones.khasab.wasBlue) then
        grname = 'F16Cap3'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'CAP mission still in progress'
    end

    mist.respawnGroup(grname, true)
end, function(sender, params)
    local grname = 'F16Cap1'
    if (zones.bandarabbas.wasBlue and zones.qeshmisland.wasBlue and zones.khasab.wasBlue) then
        grname = 'F16Cap2'
    elseif (zones.delta.wasBlue and zones.factory.wasBlue and zones.khasab.wasBlue) then
        grname = 'F16Cap3'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'CAP mission still in progress'
    end

    mist.respawnGroup(grname, true)
end)


-- Destroy existing SEAD group
Group.getByName('sead1'):destroy()

-- Initialize SEAD target menu
local seadTargetMenu = nil

-- Register shop item for SEAD mission
bc:registerShopItem('sead', 'F/A-18C SEAD mission', 250, function(sender)
    local gr = Group.getByName('sead1')
    if gr and gr:getSize() > 0 and gr:getController():hasTask() then
        return 'SEAD mission still in progress'
    end
    mist.respawnGroup('sead1', true)

    if seadTargetMenu then
        return 'Choose target zone from F10 menu'
    end

    local launchAttack = function(target)
        if Group.getByName('sead1') then
            local err = bc:engageZone(target, 'sead1')
            if err then
                return err
            end

            trigger.action.outTextForCoalition(2, 'F/A-18C Hornets engaging SAMs at ' .. target, 15)
        else
            trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
        end

        seadTargetMenu = nil
    end

    seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD Target', launchAttack, 1)

    trigger.action.outTextForCoalition(2, 'F/A-18C Hornets on route. Choose target zone from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        local gr = Group.getByName('sead1')
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'SEAD mission still in progress'
        end

        mist.respawnGroup('sead1', true)
        mist.scheduleFunction(function(target)
            if Group.getByName('sead1') then
                local err = bc:engageZone(target, 'sead1')
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F/A-18C Hornets engaging SAMs at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)


Group.getByName('cas1'):destroy()
local casTargetMenu = nil
bc:registerShopItem('cas', 'F-16 Ground Attack', 400, function(sender)
    local gr = Group.getByName('cas1')
    if gr and gr:getSize() > 0 and gr:getController():hasTask() then
        return 'Ground attack mission still in progress'
    end
    
    mist.respawnGroup('cas1', true)
    
    if casTargetMenu then
        return 'Choose target zone from F10 menu'
    end
    
    local launchAttack = function(target)
        if casTargetMenu then
            if Group.getByName('cas1') then
                local err = bc:engageZone(target, 'cas1')
                if err then
                    return err
                end
                
                trigger.action.outTextForCoalition(2, 'F-16 Vipers engaging groups at ' .. target, 15)
            else
                trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
            end
            
            casTargetMenu = nil
        end
    end
    
    casTargetMenu = bc:showTargetZoneMenu(2, 'F-16 Vipers', launchAttack, 1)
    
    trigger.action.outTextForCoalition(2, 'F-16 Vipers on route. Choose target zone from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        local gr = Group.getByName('cas1')
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'Ground attack mission still in progress'
        end
        
        mist.respawnGroup('cas1', true)
        mist.scheduleFunction(function(target)
            if Group.getByName('cas1') then
                local err = bc:engageZone(target, 'cas1')
                if err then
                    return err
                end
                
                trigger.action.outTextForCoalition(2, 'F-16 Vipers engaging groups at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)

bc:addMonitoredROE('cruise1')
local cruiseMissileTargetMenu = nil
bc:registerShopItem('cruisemsl', 'Cruise Missile Strike', 800, function(sender)
    if cruiseMissileTargetMenu then
        return 'Choose target zone from F10 menu'
    end
    
    local launchAttack = function(target)
        if cruiseMissileTargetMenu then
            local err = bc:fireAtZone(target, 'cruise1', true, 8)
            if err then
                return err
            end
            
            cruiseMissileTargetMenu = nil
            trigger.action.outTextForCoalition(2, 'Launching cruise missiles at ' .. target, 15)
        end
    end
    
    cruiseMissileTargetMenu = bc:showTargetZoneMenu(2, 'Cruise Missile Target', launchAttack, 1)
    
    trigger.action.outTextForCoalition(2, 'Cruise missiles ready. Choose target zone from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        local err = bc:fireAtZone(params.zone.zone, 'cruise1', true, 8)
        if err then
            return err
        end
        
        trigger.action.outTextForCoalition(2, 'Launching cruise missiles at ' .. params.zone.zone, 15)
    else
        return 'Can only target enemy zone'
    end
end)


local upgradeMenu = nil
bc:registerShopItem('supplies', 'Resupply friendly Zone', 200, function(sender)
    if upgradeMenu then
        return 'Choose zone from F10 menu'
    end

    local upgradeZone = function(target)
        if upgradeMenu then
            local zn = bc:getZoneByName(target)
            if zn and zn.side == 2 then
                zn:upgrade()
            else
                return 'Zone not friendly'
            end
            
            upgradeMenu = nil
        end
    end
    upgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to resupply', upgradeZone, 2, true)
    
    trigger.action.outTextForCoalition(2, 'Supplies prepared. Choose zone from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 2 then
        params.zone:upgrade()
    else
        return 'Can only target friendly zone'
    end
end)

Group.getByName('jtacDrone'):destroy()
local jtacTargetMenu = nil
drone = JTAC:new({name = 'jtacDrone'})

bc:registerShopItem('jtac', 'MQ-1A Predator JTAC mission', 100, function(sender)
    if jtacTargetMenu then
        return 'Choose target zone from F10 menu'
    end
    
    local spawnAndOrbit = function(target)
        if jtacTargetMenu then
            local zn = bc:getZoneByName(target)
            drone:deployAtZone(zn)
            drone:showMenu()
            trigger.action.outTextForCoalition(2, 'Predator drone deployed over ' .. target, 15)
            jtacTargetMenu = nil
        end
    end
    
    jtacTargetMenu = bc:showTargetZoneMenu(2, 'Deploy JTAC', spawnAndOrbit, 1)
    
    trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        drone:deployAtZone(params.zone)
        drone:showMenu()
        trigger.action.outTextForCoalition(2, 'Predator drone deployed over ' .. params.zone.zone, 15)
    else
        return 'Can only target enemy zone'
    end
end)
------------------------------------ START own 9 line jtac AM START ----------------------------------
local jtacZones = {}
Group.getByName('JTAC9lineam'):destroy()
local jtacTargetMenu2 = nil
local droneAM = JTAC9line:new({name = 'JTAC9lineam'})
bc:registerShopItem('9lineam', 'Jtac 9line AM', 0, function(sender)
    if jtacTargetMenu2 then
        return 'Choose target zone from F10 menu'
    end
    
    local spawnAndOrbit2 = function(target)
        if jtacTargetMenu2 then
            local zn = bc:getZoneByName(target)
            droneAM:deployAtZone(zn)
			
			jtacZones[target] = {drone = 'JTAC9lineam'}
			
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. target .. '. Contact Springfield on 241.00 AM ', 30)
        jtacTargetMenu2 = nil
		end
    end
    
    jtacTargetMenu2 = bc:showTargetZoneMenu(2, 'Deploy JTAC to Zone', spawnAndOrbit2, 1)
    trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        droneAM:deployAtZone(params.zone)
        trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. params.zone.zone .. '. Contact Springfield on 241.00 AM ', 30)
    else
        return 'Can only target enemy zone'
    end
end)

  ------------------------------ END 9 line jtac AM END ----------------------------------
  ----------------------------- START 9 line jtac fm START ---------------------------

Group.getByName('JTAC9linefm'):destroy()
local jtacTargetMenu3 = nil
local droneFM = JTAC9linefmr:new({name = 'JTAC9linefm'})
bc:registerShopItem('9linefm', 'Jtac 9line FM', 0, function(sender)
    if jtacTargetMenu3 then
        return 'Choose target zone from F10 menu'
    end
    
    local spawnAndOrbit3 = function(target)
        if jtacTargetMenu3 then
            local zn = bc:getZoneByName(target)
            droneFM:deployAtZone(zn)
			
			jtacZones[target] = {drone = 'JTAC9linefm'}
			
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. target .. '. Contact Uzi on 31.00 FM ', 30)            
            jtacTargetMenu3 = nil
        end
    end
    
    jtacTargetMenu3 = bc:showTargetZoneMenu(2, 'Deploy JTAC to Zone', spawnAndOrbit3, 1)
    trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        droneFM:deployAtZone(params.zone)
        trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. params.zone.zone .. '. Contact Uzi on 31.00 FM ', 30)
    else
        return 'Can only target enemy zone'
    end
end)


function CheckJtacStatus()
	 if jtacZones == nil then
			return false
		end

    local jtacFound = false
    
    for zoneName, jtacInfo in pairs(jtacZones) do
        local jtacGroup = Group.getByName(jtacInfo.drone)
        if jtacGroup and Utils.isGroupActive(jtacGroup) then
            local zone = bc:getZoneByName(zoneName)
            if zone and zone.side == 0 then
                jtacGroup:destroy()
                jtacZones[zoneName] = nil
                jtacFound = true
            end
        else
            jtacZones[zoneName] = nil
        end
    end

    return jtacFound
end

  -------------------------- END 9 line jtac FM END ----------------------------------
  -------------------------- END 9 line jtac FM END ----------------------------------
Group.getByName('ewAircraft'):destroy()
local jamMenu = nil

bc:registerShopItem('jam', 'Jam radars at zone', 500, function(sender)
    local gr = Group.getByName('ewAircraft')
    if Utils.isGroupActive(gr) then 
        return 'Jamming mission still in progress'
    end
    
    mist.respawnGroup('ewAircraft', true)
    
    if jamMenu then
        return 'Choose target zone from F10 menu'
    end
    
    local startJam = function(target)
        if jamMenu then
            bc:jamRadarsAtZone('ewAircraft', target)
            jamMenu = nil
            trigger.action.outTextForCoalition(2, 'Growler jamming radars at ' .. target, 15)
        end
    end
    
    jamMenu = bc:showTargetZoneMenu(2, 'Jamming target', startJam, 1)
    trigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu', 15)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        local gr = Group.getByName('ewAircraft')
        if Utils.isGroupActive(gr) then 
            return 'Jamming mission still in progress'
        end
        
        mist.respawnGroup('ewAircraft', true)
        
        mist.scheduleFunction(function(target)
            local ew = Group.getByName('ewAircraft')
            if ew then
                local err = bc:jamRadarsAtZone('ewAircraft', target)
                if err then
                    return err
                end
                
                trigger.action.outTextForCoalition(2, 'Growler jamming radars at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
        
    else
        return 'Can only target enemy zone'
    end
end)
tanksMenu = nil
bc:registerShopItem('armor', 'Deploy armor (for combined arms)', 100, function(sender)
	if tanksMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployTanks = function(target)
		if tanksMenu then
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-tanks')
			tanksMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly armor deployed at ' .. target, 15)
		end
	end
	
	tanksMenu = bc:showTargetZoneMenu(2, 'Deploy armor (Choose friendly zone)', deployTanks, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-tanks')
		trigger.action.outTextForCoalition(2, 'Friendly armor deployed at ' .. params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
artyMenu = nil
bc:registerShopItem('artillery', 'Deploy artillery (for combined arms)', 100, function(sender)
	if artyMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployArty = function(target)
		if artyMenu then
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-arty')
			artyMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at ' .. target, 15)
		end
	end
	
	artyMenu = bc:showTargetZoneMenu(2, 'Deploy artillery (Choose friendly zone)', deployArty, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-arty')
		trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at ' .. params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
reconMenu = nil
bc:registerShopItem('recon', 'Deploy recon group (for combined arms)', 50, function(sender)
	if reconMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployRecon = function(target)
		if reconMenu then
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-recon')
			reconMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at ' .. target, 15)
		end
	end
	
	reconMenu = bc:showTargetZoneMenu(2, 'Deploy recon group (Choose friendly zone)', deployRecon, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-recon')
		trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at ' .. params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
airdefMenu = nil
bc:registerShopItem('airdef', 'Deploy air defence (for combined arms)', 150, function(sender)
	if airdefMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployAirDef = function(target)
		if airdefMenu then
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-airdef')
			airdefMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..target, 15)
		end
	end
	
	airdefMenu = bc:showTargetZoneMenu(2, 'Deploy air defence (Choose friendly zone)', deployAirDef, 2)
	trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-airdef')
		trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)
bc:addShopItem(2, '9lineam', -1)
bc:addShopItem(2, '9linefm', -1)
bc:addShopItem(2, 'cap', -1)
bc:addShopItem(2, 'sead', -1)
bc:addShopItem(2, 'cas', -1)
bc:addShopItem(2, 'supplies', -1)
bc:addShopItem(2, 'jtac', -1)
bc:addShopItem(2, 'jam', -1)
bc:addShopItem(2, 'cruisemsl', 12)
bc:addShopItem(2, 'armor', -1)
bc:addShopItem(2, 'artillery', -1)
bc:addShopItem(2, 'recon', -1)
bc:addShopItem(2, 'airdef', -1)
supplyZones = {
    'Sharjah',
    'BandarAbbas',
    'Factory',
    'Khasab',
    'Delta',
    'Echo',
    'Golf',
    'Carrier Group',
    'Factory',
    'Khamets',
    'Kish intl',
    'Bandar Lengeh',
    'Sunny',
    'Ramp-Kongo',
    'Al Dhafra',
    'Al Huti',
    'Al Ain',
    'Fujairah Intl',
    'Al Minhad AFB',
    'Ras Al Khaimah',
    'Al Khatim',
    'Al Dahid',
    'Radio Tower',
    'Qeshm Island',
	'Paregaan',
	'Samathe',
	'LAR'

}
lc = LogisticCommander:new({battleCommander = bc, supplyZones = supplyZones})
lc:init()

bc:loadFromDisk() -- will load and overwrite default zone levels, sides, funds, and available shop items
bc:init()
bc:startRewardPlayerContribution(15, {infantry = 10, ground = 20, sam = 40, airplane = 50, ship = 250, helicopter = 50, crate = 200, rescue = 100})

HercCargoDropSupply.init(bc)

evc = EventCommander:new({ decissionFrequency=30*60, decissionVariance=30*60, skipChance = 10})
evc:init()

bandarforce = {
	['Echo'] = { 'krymsk-force-1' , 'krymsk-force-2', 'krymsk-force-3'},
	['Delta'] = { 'krymsk-tforce-1' },
	['Kish intl'] = { 'evt-kish-sead-attack-bandar' },
	['Lar'] = { 'krymsk-aforce-1', 'krymsk-aforce-3' }

}
for i,v in pairs(bandarforce) do
	for _,v2 in ipairs(v) do
		Group.getByName(v2):destroy()
	end
end
evc:addEvent({
	id='bandarattack',
	action = function()
		for i,v in pairs(bandarforce) do
			if bc:getZoneByName(i).side == 1 then
				for _,v2 in ipairs(v) do
					mist.respawnGroup(v2, true)
				end
			end
		end
	end,
	canExecute = function()
		if math.random(1,100) < 60 then return false end
		
		if bc:getZoneByName('BandarAbbas').side ~= 2 then return false end
		
		local canAttack = false
		for i,v in pairs(bandarforce) do
			if bc:getZoneByName(i).side == 1 then canAttack = true end
			
			for _,v2 in ipairs(v) do
				if Group.getByName(v2) then return false end
			end
		end
		
		return canAttack
	end
})
Group.getByName('oscar-scud-1'):destroy()
evc:addEvent({
	id='scuds',
	action = function()
		mist.respawnGroup('oscar-scud-1')
		
		timer.scheduleFunction(function(param, time)
			if Group.getByName('oscar-scud-1') then
				local tgts = {
					'Qeshm Island',
					'BandarAbbas',
					'Khasab',
					'Delta',
					'Echo',
					'Oil Fields',
					'Ras Al Khaimah',
					'Sharjah'
					
				}
				
				local validtgts = {}
				for _,v in ipairs(tgts) do
					if bc:getZoneByName(v).side == 2 then
						table.insert(validtgts, v)
					end
				end
				
				if #validtgts == 0 then return time+(10*60) end
				
				local die = math.random(1,#validtgts)
				local choice = validtgts[die]
				bc:fireAtZone(choice, 'oscar-scud-1', false, 8)
				trigger.action.outTextForCoalition(2, 'SCUDS near Foxtrot (30), are launching at '..choice, 15)
			end
		end, {}, timer.getTime()+(20*60))
	end,
	canExecute = function()
		local gr = Group.getByName('oscar-scud-1')
		if gr then return false end
		
		if bc:getZoneByName('Foxtrot').side ~= 1 then return false end
		
		local triggers = {'BandarAbbas', 'Qeshm Island', 'Ramp-Kongo', 'Lar'}
		for _,v in ipairs(triggers) do
			if bc:getZoneByName(v).side == 2 then
				return true
			end
		end
		
		return false
	end
})
Group.getByName('lar-attack-ramp-kongo-event'):destroy()
Group.getByName('lar-attack-sunny-event'):destroy()
Group.getByName('lar-attack-echo-event'):destroy()
Group.getByName('Lar-attack-golf-event'):destroy()
Group.getByName('lar-attack-foxtrot-event'):destroy()

evc:addEvent({
	id = 'helohunt',
	action = function()

		local groupsAndTargets = {
			{group = 'lar-attack-ramp-kongo-event', target = 'Ramp-Kongo'},
			{group = 'lar-attack-sunny-event', target = 'Sunny'},
			{group = 'lar-attack-echo-event', target = 'Echo'},
			{group = 'Lar-attack-golf-event', target = 'Golf'},
			{group = 'lar-attack-foxtrot-event', target = 'Foxtrot'}
		}


		for _, entry in ipairs(groupsAndTargets) do
			mist.respawnGroup(entry.group, true)
		end


		timer.scheduleFunction(function(param, time)
			for _, entry in ipairs(groupsAndTargets) do
				local zone = bc:getZoneByName(entry.target)

				if zone.side == 2 then
					if Group.getByName(entry.group) then
						bc:engageZone(entry.target, entry.group)
					end
				end
			end
		end, {}, timer.getTime() + 3)
	end,
	
	canExecute = function()

		if math.random(1, 100) < 60 then 
			return false 
		end


		if bc:getZoneByName('Lar').side ~= 1 then return false end


		local triggers = {'Foxtrot', 'Golf', 'Ramp-Kongo', 'Sunny', 'Echo'}
		for _, v in ipairs(triggers) do
			if bc:getZoneByName(v).side == 2 then
				return true
			end
		end

		return false
	end
})
Group.getByName('evt-cas'):destroy()
evc:addEvent({
	id='cas',
	action = function()
		mist.respawnGroup('evt-cas', true)
		
		timer.scheduleFunction(function(param, time)
			local tgts = {
				'BandarAbbas',
				'Khasab',
				'Qeshm Island',
				'Delta',
				'Echo'

			}
			
			local validtgts = {}
			for _,v in ipairs(tgts) do
				if bc:getZoneByName(v).side == 2 then
					table.insert(validtgts, v)
				end
			end
			
			if #validtgts ~= 0 then
				local die = math.random(1,#validtgts)
				local choice = validtgts[die]
				
				if Group.getByName('evt-cas') then
					bc:engageZone(choice, 'evt-cas')
				end
			end
		end, {}, timer.getTime()+3)
	end,
	canExecute = function()
		local gr = Group.getByName('evt-cas')
		if gr then return false end
		
		if bc:getZoneByName('Lar').side ~= 1 then return false end
		
		local triggers = {'BandarAbbas', 'Khasab', 'Qeshm Island'}
		for _,v in ipairs(triggers) do
			if bc:getZoneByName(v).side == 2 then
				return true
			end
		end
		
		return false
	end
})
mc = MissionCommander:new({side = 2, battleCommander = bc, checkFrequency = 60})
mc:trackMission({
    title = "Helo Hunt LAR",
    description = "Large number of KA-50 taking off from LAR heading to our closest friendly bases\nDestroy them before they get in range.",
    messageStart = "New mission: Helo hunt\nLarge number of KA-50 takingoff from LAR heading to our closest friendly bases\n\nDestroy them before they get in range.",
    messageEnd = "Mission ended: Helo hunt",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        captureTarget = nil
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        local groups = {
            'lar-attack-ramp-kongo-event',
            'lar-attack-sunny-event',
            'lar-attack-echo-event',
            'Lar-attack-golf-event',
            'lar-attack-foxtrot-event',

        }
        for _, groupName in ipairs(groups) do
            if Group.getByName(groupName) then
                return true
            end
        end
        return false
    end
})
mc:trackMission({
	title = "Destroy artillery",
	description = "Artillery has been spotted heading towards Delta from the direction of Echo.\nDestroy them before they get in range.",
	messageStart = "New mission: Destroy artillery",
	messageEnd = "Mission ended: Destroy artillery\n+50 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        captureTarget = nil
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	reward = 50,
	isActive = function()
		local gr = Group.getByName('Echo-attack-delta-art')
		if gr then return true else return false end
	end
})
mc:trackMission({
	title = "Destroy artillery",
	description = "The enemy has deployed artillery near Foxtrot. Destroy it before it has a chance to fire.",
	messageStart = "New mission: Destroy artillery",
	messageEnd = "Mission ended: Destroy artillery\n+50 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        captureTarget = nil
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	reward = 50,
	isActive = function()
		local gr = Group.getByName('foxtrot-artillery-fire-at-golf')
		if gr then return true else return false end
	end
})
mc:trackMission({
	title = "Defend BandarAbbas",
	description = "The enemy is preparing an all out attack on BandarAbbas.\nDefend the airfield at all cost.",
	messageStart = "New mission: Defend BandarAbbas",
	messageEnd = "Mission ended: Defend BandarAbbas",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        captureTarget = nil
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	isActive = function()
		for i,v in pairs(bandarforce) do
			for _,v2 in ipairs(v) do
				if Group.getByName(v2) then return true end
			end
		end
		
		return false
	end
})
mc:trackMission({
	title = "Destroy SCUDS, (30)",
	description = "SCUDS have been spotted at Foxtrot, 30).\nDestroy them before they can launch their missiles",
	messageStart = "New mission: Destroy SCUDS",
	messageEnd = "Mission ended: Destroy SCUDS",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        captureTarget = nil
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	isActive = function()
		local gr = Group.getByName('oscar-scud-1')
		if gr then return true else return false end
	end
})
resupplyTarget = nil
mc:trackMission({
    title = function()
        local wp = WaypointList[resupplyTarget] or ""
        return "Resupply " .. resupplyTarget .. wp
    end,
    description = function()
        return "Deliver supplies to " .. resupplyTarget end,
    messageStart = function()
        local wp = WaypointList[resupplyTarget] or ""
        return "New mission: Resupply " .. resupplyTarget .. wp
    end,
    messageEnd = function()
        return "Mission ended: Resupply " .. resupplyTarget end,
    startAction = function()
        if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not resupplyTarget then return false end

        local targetzn = bc:getZoneByName(resupplyTarget)
        return targetzn:canRecieveSupply()
    end
})
attackTarget = nil
mc:trackMission({
    title = function()
        local wp = WaypointList[attackTarget] or ""
        return "Attack " .. attackTarget .. wp
    end,
    description = function()
        local wp = WaypointList[attackTarget] or ""
        return "Destroy enemy forces at " .. attackTarget end,
    messageStart = function()
        local wp = WaypointList[attackTarget] or ""
        return "New mission: Attack " .. attackTarget .. wp
    end,
    messageEnd = function()
        return "Mission ended: Attack " .. attackTarget end,
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cas.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not attackTarget then return false end
        local targetzn = bc:getZoneByName(attackTarget)
        return targetzn.side == 1
    end
})


captureTarget = nil
mc:trackMission({
    title = function()
        local wp = WaypointList[captureTarget] or ""
        return "Capture " .. captureTarget .. wp
    end,
    description = function()
        return captureTarget .. " is neutral. Capture it by delivering supplies" end,
    messageStart = function()
        local wp = WaypointList[captureTarget] or ""
        return "New mission: Capture " .. captureTarget .. wp
    end,
    messageEnd = function()
        return "Mission ended: Capture " .. captureTarget end,
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not captureTarget then return false end

        local targetzn = bc:getZoneByName(captureTarget)
        return targetzn.side == 0 and targetzn.active
    end
})

function generateCaptureMission()
    if captureTarget ~= nil then return end
    
    local validzones = {}
    for _,v in ipairs(bc.zones) do
        
        if v.active and v.side == 0 and (not v.NeutralAtStart or v.firstCaptureByRed) then
            
            table.insert(validzones, v.zone)
        end
    end
    
    if #validzones == 0 then return end
    
    local choice = math.random(1, #validzones)
    if validzones[choice] then
        captureTarget = validzones[choice]
        return true
    end
end
function generateAttackMission()
	if attackTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.connections) do
		local to = bc:getZoneByName(v.to)
		local from = bc:getZoneByName(v.from)
		
		if from.side ~= to.side and from.side ~= 0  and to.side ~= 0 and from.active and to.active then
			if from.side == 1 then
				table.insert(validzones, from.zone)
			elseif to.side == 1 then
				table.insert(validzones, to.zone)
			end
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		attackTarget = validzones[choice]
		return true
	end
end
function generateSupplyMission()
    if missionCompleted then return end
    if resupplyTarget ~= nil then return end

    local validzones = {}
    for _, v in ipairs(bc.zones) do
        if v.side == 2 and v:canRecieveSupply() then
            table.insert(validzones, v.zone)
        end
    end

    if #validzones == 0 then return end

    local choice = math.random(1, #validzones)
    if validzones[choice] then
        resupplyTarget = validzones[choice]
        return true
    end
end
timer.scheduleFunction(function(_, time)
	if generateCaptureMission() then
		return time + 300
	else
		return time + 120
	end
end, {}, timer.getTime() + 20)

timer.scheduleFunction(function(_, time)
	if generateAttackMission() then
		return time + 300
	else
		return time + 120
	end
end, {}, timer.getTime() + 40)

timer.scheduleFunction(function(_, time)
	if generateSupplyMission() then
		return time + 300
	else
		return time + 120
	end
end, {}, timer.getTime() + 60)
mc:init()
----------------------- FLAGS --------------------------
local function checkZoneFlags()

	if zones.khasab.wasBlue then
        trigger.action.setUserFlag(5, true)	
    end

	if zones.khaimah.wasBlue then
        trigger.action.setUserFlag(1, true)	
    end

	if zones.echo.wasBlue then
        trigger.action.setUserFlag(132, true)	
    end

	if zones.golf.wasBlue then
        trigger.action.setUserFlag(133, true)	
    end
end
timer.scheduleFunction(function()
    checkZoneFlags()
    return timer.getTime() + 30
end, {}, timer.getTime() + 3)
----------------------- END OF FLAGS --------------------------


env.info("ZoneSetup: is completed!")

